-- relations of database chirokey_adults 2009-04-08 13:51:35

USE `phpmyadmin`;
INSERT INTO `pma_table_info` (`db_name`, `table_name`, `display_field`) VALUES
('chirokey_adults', 'images', 'filename'),
('chirokey_adults', 'morph_attrib', 'morph_long'),
('chirokey_adults', 'names_authors', 'authors_short'),
('chirokey_adults', 'names_genera', 'name'),
('chirokey_adults', 'names_species', 'name'),
('chirokey_adults', 'names_subfamily', 'name'),
('chirokey_adults', 'names_subgenus', 'name'),
('chirokey_adults', 'names_subtribe', 'name'),
('chirokey_adults', 'names_synonyms', 'id'),
('chirokey_adults', 'names_tribe', 'name'),
('chirokey_adults', 'names_valid', 'id'),
('chirokey_adults', 'users', 'username');

INSERT INTO `pma_relation` (`master_db`, `master_table`, `master_field`, `foreign_db`, `foreign_table`, `foreign_field`) VALUES
('chirokey_adults', 'characters', 'names_authors_id', 'chirokey_adults', 'names_authors', 'id'),
('chirokey_adults', 'characters', 'names_valid_id', 'chirokey_adults', 'names_valid', 'id'),
('chirokey_adults', 'images', 'morph_id', 'chirokey_adults', 'morph_attrib', 'id'),
('chirokey_adults', 'images', 'names_authors_id', 'chirokey_adults', 'names_authors', 'id'),
('chirokey_adults', 'images', 'names_valid_id', 'chirokey_adults', 'names_valid', 'id'),
('chirokey_adults', 'images', 'users_id', 'chirokey_adults', 'users', 'id'),
('chirokey_adults', 'names_synonyms', 'author_name_id', 'chirokey_adults', 'names_authors', 'id'),
('chirokey_adults', 'names_synonyms', 'genus_name_id', 'chirokey_adults', 'names_genera', 'id'),
('chirokey_adults', 'names_synonyms', 'species_name_id', 'chirokey_adults', 'names_species', 'id'),
('chirokey_adults', 'names_synonyms', 'subfamily_name_id', 'chirokey_adults', 'names_subfamily', 'id'),
('chirokey_adults', 'names_synonyms', 'valid_name_id', 'chirokey_adults', 'names_valid', 'id'),
('chirokey_adults', 'names_valid', 'descriptor_name_id', 'chirokey_adults', 'names_authors', 'id'),
('chirokey_adults', 'names_valid', 'genus_name_id', 'chirokey_adults', 'names_genera', 'id'),
('chirokey_adults', 'names_valid', 'species_name_id', 'chirokey_adults', 'names_species', 'id'),
('chirokey_adults', 'names_valid', 'subfamily_name_id', 'chirokey_adults', 'names_subfamily', 'id'),
('chirokey_adults', 'names_valid', 'subgenus_name_id', 'chirokey_adults', 'names_subgenus', 'id'),
('chirokey_adults', 'names_valid', 'subtribe_name_id', 'chirokey_adults', 'names_subtribe', 'id'),
('chirokey_adults', 'names_valid', 'tribe_name_id', 'chirokey_adults', 'names_tribe', 'id');
