<?
/** Config part: */
  $allowedImWidthHeight = 1000;// px
  $allowedImSize        = 500;// kB
  $debug                = false; // show detailed information in calculations (output is quite large)
  // path for including outline library 'inc.outline.php':
  /* include $_SERVER['DOCUMENT_ROOT']."/path/to/the/classfile/inc.outline.php"; */
  include "inc.outline.php";

/** check variables*/
  $textadd=isset($_POST['fileSended'])? $_FILES['loadedImage']['name']:"";
  $textadd=isset($_POST['chainSubmitted'])? "for given chaincode":$textadd;
  $textadd=empty($textadd)? "for a given file/chaincode":$textadd;
  $stop=false;

/** check image properties*/
  #echo $stop?"stop is true<br>":"stop is false<br>";
  if(isset($_POST['fileSended'])){
    /** wrong file type */
    if(!preg_match("/image\/(png|gif|jpeg|bmp)/",$_FILES['loadedImage']['type'])){
      $cause= "File '".$_FILES['loadedImage']['name']."' (".$_FILES['loadedImage']['type'].") is no image file. ";
      $stop=true;
    }
    #echo $stop?"stop is true<br>":"stop is false<br>";
    /** file size to much */
    $stop=($_FILES['loadedImage']['size'] > 1024* $allowedImSize) ? true:$stop;
    $cause.=($stop==true && $_FILES['loadedImage']['size'] > 1024* $allowedImSize)? "File size is more than allowed size of ".$allowedImSize."kB (".round($_FILES['loadedImage']['size']/1024,2)." kB). ":"";

    /** file width or height to much */
    $size = GetImageSize (
      $_FILES['loadedImage']["tmp_name"]
      #,&$info # erweiterte Informationen aus der Datei
      );
    $stop=($size[0]> $allowedImWidthHeight || $size[1] > $allowedImWidthHeight)? true:$stop;
    $cause.=$stop==true && !empty($size)? "File width or height is > 600px (".$size[3]."). ":"";
  } else $stop=false;
  #echo $stop?"stop is true<br>":"stop is false<br>";
  $textadd.=$stop?" Error":"";
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
"http://www.w3.org/TR/html4/strict.dtd">

<head>
  <title>Outline with Fourier Analysis (<?=$textadd;?>) version 2008-10-22</title>
<!--   <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"> -->
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <meta http-equiv="expires" content="0">
  <style type="text/css">

ol.preformatted{
  list-style:decimal outside;
/*   border:2px solid gray; */
  background-color: #EEEED1;
  padding-left:3em;
/*   border-top:1px solid red; */
  margin:0px;
}
ol.preformatted li {
  font-family:  monospace;
    white-space : pre;
  background-color: white;
}
div.preformattedLi{
  font-family:  monospace;
  white-space:pre;
/*   background-color: white; */
/*   padding-left:3em; */
  background-color: #EEEED1;
  border-bottom:1px solid red;
  margin-top:1em;
  margin-bottom:0px;
}
div.preformatted{
  font-family: "Courier New", Courier, monospace;
  white-space : pre;
/*   background-color: white; */
/*   padding-left:3em; */
  background-color: #EEEED1;
/*   border-bottom:1px solid red; */
/*   margin-top:1em; */
  margin-bottom:0px;
}

td {
  vertical-align:top;
}
.digits4 {
  width:4em;
  text-align:right;
}

</style>
</head>
<body>
  <h2 style="text-align:center;">Outline with Fourier Analysis (<?=$textadd;?>)<br>version 2008-10-22</h2>

<?php
/* Es wird ein Array aus 4 Elementen zurück gegeben. Im Array-Index 0 steht die
Breite. Index 1 enthält die Höhe, 2 ein Flag je nach Grafik-Typ (1 = GIF, 2 =
JPG, 3 = PNG, SWF = 4) und Index 3 die richtige Zeichenkette im Format
"height=xxx width=xxx" zur Verwendung im IMG-Tag von HTML.
Beispiel 1. Grafik-Ausmaße ermitteln per GetImageSize:
*/

/*
Array
(
    [0] => 454
    [1] => 193
    [2] => 2
    [3] => width="454" height="193"
    [bits] => 8
    [channels] => 1
    [mime] => image/jpeg
)
 */
if($stop==true){
  echo "<p style='color:red;text-align:center;font-size : x-large;'>".$cause." Stop here.</p>";
} elseif(isset($_POST['nharmo'])) {
  echo "<p style='text-align:center;font-size : large;'>Output is given below.</p>";
}

?>
<!-- <script type="text/javascript"> -->
<!-- document.sendfile.loadedImage.value=="" -->
<!-- document.all.textarea.wrap=(document.all.textarea.wrap=='off')?'soft':'off'; -->
<!-- return (document.sendfile.loadedImage.value=="")?alert('Select a file to be analyzed!');false;:true; -->
<!-- </script> -->

<p style="text-align:justify;">Fourier Analysis is done after: <br>
Kuhl, Frank P. and Giardina, Charles R., 1982: <em>Elliptic Fourier features of a closed contour</em>, Computer Graphics and Image Processing, vol.&nbsp;18, no.&nbsp;3, pp.&nbsp;236-258. <br>(Abstract: A direct procedure for obtaining the Fourier coefficients of a chain-encoded contour is presented. Advantages of the procedure are that it does not require integration or the use of fast Fourier transform techniques, and that bounds on the accuracy of the image contour reconstruction are easy to specify. Elliptic properties of the Fourier coefficients are shown and used for a convenient and intuitively pleasing procedure of normalizing a Fourier contour representation. Extension of the contour representation to arbitrary objects at arbitrary aspect angle is discussed. The procedures have direct application to a variety of pattern recognition problems that involve analysis of well-defined image contours.)</p>
<table>
<tr>
  <td>
    <fieldset><legend>Outline to (normalized) elliptic Fourier transformation</legend>
    <form action="outline.php" method="post" name="sendfile" enctype="multipart/form-data">
      <table>
        <tr>
          <td>Select one file as b/w image:<br>
          <input name="loadedImage" type="file"><br>
          <span style="font-size : x-small;">(PNG is recommended; *.GIF, *.JPG, *.BMP)</span>
          </td>
        </tr>
        <tr>
          <td>Number of harmonics:<br><input name="nharmo" type="text"  value="<?= isset($_POST['nharmo'])? $_POST['nharmo'] : "200"; ?>" class="digits4" title="number of harmonics">
          </td>
        </tr>
        <tr>
          <td style="border-top:1px solid;text-align:right;">  <input type="submit" name='fileSended' value="Send file" onclick="if(document.forms['sendfile'].elements['loadedImage'].value==''){alert('Select a file to be analyzed!');return false;}else{return true;}">
          </td>
        </tr>
        <tr>
          <td>
          This PHP script recognizes only 1 outline as seen below by starting from the top left corner downward in y-direction. Untill the real outline is found there should be no single dark pixel within the top left image area. This will produce an error.<br><img src="./img/outlinemethod.png">
          </td>
        </tr>
      </table>
    </form>
    </fieldset>
  </td>
  <td>
    <fieldset><legend>Chaincode to (normalized) elliptic Fourier transformation</legend>
    <form action="outline.php" method="post" name="sendchain" enctype="multipart/form-data">
      <table>
        <tr>
          <td>Insert chain code:
            <div class="preformatted" style="text-align:left;">
 Chaincode usu-
 ally without
 spaces:
  3   2   1
    \ | /
  4 - X - 0
    / | \
  5   6   7
            </div>

          </td>
          <td><textarea name="chain" style="width:30em;height:30em;" wrap="on"  ><?= isset($_POST['chain'])? $_POST['chain'] : ""; ?></textarea></td>
        </tr>
        <tr>
          <td style="border-bottom:1px solid;"></td>
          <td style="border-bottom:1px solid;">Number of harmonics:<br><input name="nharmo" type="text"  value="<?= isset($_POST['nharmo'])? $_POST['nharmo'] : "200"; ?>" class="digits4" title="number of harmonics"></td>
        </tr>
        <tr>
          <td ></td>
          <td style="text-align:right;">  <input name="chainSubmitted" type="submit" value="Send chain" onclick="if(document.forms['sendchain'].elements['chain'].value==''){alert('There is no chaincode given!');return false;}else{return true;}"></td>
        </tr>
      </table>

    <!--   <input name="loadedImage[]" type="file"><br> -->
    </form>
    </fieldset>
  </td>
</tr>
</table>
<?
#print_pre($_POST);
  function print_pre($values){
    echo "\n<pre>\n";
      print_r($values);
    echo "\n</pre>\n";
  }
  function sci($x, $d=-1) {
    $min=($x<0)?"-":"+";
    $x=abs($x);
    $e=floor(($x==0)?0 : ($x==1? 0:log10($x)));
    #$e = ($x==1 && $e==-1)? 0:$x;
    $x*=pow(10, -$e);
    $fmt=($d>=0)?".".$d:"";
    $e=($e>=0)?"+".sprintf("%02d",$e):"-".sprintf("%02d",-$e);
    //     return $x;
    //     return sprintf("%+.10f",$x);
    // echo "\"$min%".$fmt."fe%s\"".",".$x.",".$e;
    $number = sprintf("$min%".$fmt."fe%s",$x,$e);
    return $number;
  }
  function calc_user(&$item, $key, $calc){
    // e.g.:  array_walk($array, 'calc_user', '-('.$const.')');
    #echo "return $item$calc;<br>";
    $item = eval("return $item$calc;");
  }

  if($stop) exit;
  $test = new outline;
  $math = new mathuser;


if(isset($_FILES['loadedImage'])){

/*  if(!preg_match("/image\/(png|gif|jpeg)/",$_FILES['loadedImage']['type'])){
    echo "<p style='color:red;'> '".$_FILES['loadedImage']['name']."' (".$_FILES['loadedImage']['type'].") is no image file. Stop here.<p>";
    exit;
  }*/
    $size = GetImageSize (
      $_FILES['loadedImage']["tmp_name"]
      #,&$info # erweiterte Informationen aus der Datei
      );

  $im=$test->imagecreatefromfile($_FILES['loadedImage']['tmp_name'], true);

//   print_pre($size);
  $chain =  $test->imageDrawOutline(
    $im,
    $size,
    $debug); // switch above at config
//     print_pre($chain);
//     exit;
  $output = $math->chainToXY($chain);
  $x = $output['X']; $y = $output['Y'];
  #$imparams = $test->imageOutline($x, $y);
  #print_pre($imparams);
  $printHarm =true;

}# end if loadedImage exist
if(isset($_POST['chain'])){
  if(empty($_POST['chain'])){
    echo "<p>Empty chain code given. Stopped here.</p></body>";
    exit;
  }
  $search = array(
    /* 1*/ "/\s*/",     // white spaces
    /* 2*/ "/[\r\n]/",  // line break tabs
    /* 3*/ "/([0-7])/", // add white space for explode()
    /* 4*/ "/\s+$/"     // remove last white space for explode()

    );
  $replace = array(
    /* 1*/ "",     // white spaces
    /* 2*/ "",     // line break tabs
    /* 3*/ "\\1 ", // add white space for explode()
    /* 4*/ ""      // remove last white space for explode()
  );
  $chain= preg_replace($search,$replace,$_POST['chain']);
  $chain =  explode(" ",$chain);
  $output = $math->chainToXY($chain);
  $printHarm =true;
}# end isset($_POST['chain'])

if($printHarm){
  $harmonics = $math->getharmonics(
      $chain=$chain,
      $_POST['nharmo'],
      $debug// switch above at config
    );
  /** print x y values */
  $n = count($harmonics['normalized']["a"]);
  $x = $math->harmonicsToXY($n,
    $a = $harmonics['notnormalized']["a"],
    $b = $harmonics['notnormalized']["b"],
    $t = $n);
  $y = $math->harmonicsToXY($n,
    $a = $harmonics['notnormalized']["c"],
    $b = $harmonics['notnormalized']["d"],
    $t = $n  );
  $xn = $math->harmonicsToXY($n,
    $a = $harmonics['normalized']["a"],
    $b = $harmonics['normalized']["b"],
    $t = $n);
  $yn = $math->harmonicsToXY($n,
    $a = $harmonics['normalized']["c"],
    $b = $harmonics['normalized']["d"],
    $t = $n  );

  $textadd=isset($_POST['fileSended'])? $_FILES['loadedImage']['name']:"given chaincode";

  $xim = $xn;
  $yim = $yn;
  $xshift = min($xim)<0? abs(min($xim)):0;
  $yshift = min($yim)<0? abs(min($yim)):0;
 array_walk($xim, 'calc_user', '+'.$xshift);
 array_walk($yim, 'calc_user', '+'.$yshift);
  $scale=empty($size) ? 200 : $size[0]/max($xim);
 array_walk($xim, 'calc_user', '*'.$scale);
 array_walk($yim, 'calc_user', '*'.$scale);
 if(isset($_POST['fileSended']) || !empty($chain)){
 echo "
<table>
 ";
  echo isset($_POST['fileSended'])? "<tr>\n  <td style='text-align:center;'>Original Image:<br>":"";
    isset($_POST['fileSended'])? $test->imageOutline($output['X'], $output['Y'], $dst="./temp/source.png", $textadd):"";
  echo isset($_POST['fileSended'])? "\n</td>\n </tr>\n":"";
  echo "<tr>\n  <td style='text-align:center;'>Reconstructed Image:<br>";
    empty($chain)? "": $test->imageOutline($xim, $yim, $dst="./temp/outlined.png",$textadd);
 echo "
  </td>
 </tr>
</table>
 ";
 unset($xim,$yim);
 }

$nchain=count($chain);
echo <<<EOF
<div class="preformattedLi">
Chaincode  |    3   2   1
usually    |      \ | /
without    |    4 - X - 0
space and  |      / | \
line break |    5   6   7
-----------+--------------

$nchain points as outline for $textadd
(in counter clockwise direction as in program <a href='http://life.bio.sunysb.edu/morph/' target='_blank'>SHAPE, see http://life.bio.sunysb.edu/morph/):</a>

     1   5   10   15   20   25   30   35   40   45   50   55   60   65   70   75   80   85   90   95  100
</div>
<ol class="preformatted" start=0 >

EOF;
$outputChain = wordwrap(implode("", $chain),100, "\n", true);
$search = array(
  "/^([0-7])([0-7]{3})([0-7])/m",
  "/([0-7]{4})([0-7])/",
  "/^(.+)$/m"
);
$replace = array(
  "<span style='color:red'>\\1</span>\\2<span style='color:red'>\\3</span>",
   "\\1<span style='color:red'>\\2</span>",
   "\n  <li>\\1</li>"
);
$outputChain=preg_replace($search, $replace, $outputChain);
echo $outputChain."\n
</ol>";
echo <<<EOF
<div class="preformattedLi">
Data for $textadd:
  N  +------------ NOT normalized elliptic Fourier -------------+
Harm |            a              b              c              d|
</div>
<ol class="preformatted">
EOF;
  foreach ($harmonics['notnormalized']["a"] as $key => $value) {
    echo
    " <li>".
    sci($harmonics['notnormalized']["a"][$key], 7)." ".
    sci($harmonics['notnormalized']["b"][$key], 7)." ".
    sci($harmonics['notnormalized']["c"][$key], 7)." ".
    sci($harmonics['notnormalized']["d"][$key], 7)."</li>\n";
  }
echo "\n</ol>\n";
echo <<<EOF
<div class="preformattedLi">
Data for $textadd:
  N  +- x-y coordinates not normalized +
Harm |            x              y     |
</div>
<ol class="preformatted">
EOF;
  foreach ($x as $key => $value) {
    echo
    " <li>".
    sci($x[$key], 7)." ".
    sci($y[$key], 7)."</li>\n";
  }
  echo <<<EOF
</ol>
<div class="preformattedLi">
Data for $textadd:
  N  +------------- normalized elliptic Fourier ----------------+
Harm |            a              b              c              d|
</div>
<ol class="preformatted">
EOF;
  foreach ($harmonics['normalized']["a"] as $key => $value) {
    echo
    " <li>".
    sci($harmonics['normalized']["a"][$key], 7)." ".
    sci($harmonics['normalized']["b"][$key], 7)." ".
    sci($harmonics['normalized']["c"][$key], 7)." ".
    sci($harmonics['normalized']["d"][$key], 7)."</li>\n";
  }
echo "\n</ol>\n";
echo <<<EOF
<div class="preformattedLi">
Data for $textadd:
  N  +- x-y coordinates normalized +
Harm |        xnorm         ynorm  |
</div>
<ol class="preformatted">
EOF;
  foreach ($xn as $key => $value) {
    echo
    " <li>".
    sci($xn[$key], 7)." ".
    sci($yn[$key], 7)."</li>\n";
  }

echo "\n</ol>\n";
  #print_pre($_POST);
}// end print harmonics

#harmonic.simple(x=1:n,a0=0,a=nefdf$nefabcd[,"a"],b=nefdf$nefabcd[,"b"],n,1:n)#;
  #print_pre(implode("\n",$x));
  #print_pre($math->ave_user($y));
  #print_pre($math->ave_user($x));
//   imagegif()*/
   ?>

</body>
<?
?>