<?php
/**
 * Show morphology
 *
 *
 * @author Andreas Plank <andreas.plank@web.de>
 * @version 2009-02-24 21:24:33
 * @license Noncommercial-Share Alike 3.0 Unported
 * @todo minor issue: document further detailed
 * @category determination key
 * @package chirokey_larvae
 * @subpackage key
 */
header('content-type: text/html; charset=utf-8');
 ?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>

<head>
  <title>larval morphology</title>
  <meta name="GENERATOR" content="Quanta Plus">
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <script type='text/javascript' language='JavaScript' src='../structure/js/overlib.js'></script>
  <link rel="stylesheet" href="../structure/css/basic.css" type="text/css">
</head>
<body >
<div id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></div>
<!--  page content  -->
<div class="content">
<script type='text/javascript' language="JavaScript1.2">

/***********************************************
* Sliding Menu Bar Script- © Dynamic Drive (www.dynamicdrive.com)
* Visit http://www.dynamicdrive.com/ for full source code
* This notice must stay intact for use
***********************************************/

var slidemenu_width='220px' //specify width of menu (in pixels)
var slidemenu_reveal='20px' //specify amount that menu should protrude initially
var slidemenu_top='20px'   //specify vertical offset of menu on page

var ns4=document.layers?1:0
var ie4=document.all
var ns6=document.getElementById&&!document.all?1:0

if (ie4||ns6)
document.write('<div id="slidemenubar2" style="left:'+((parseInt(slidemenu_width)-parseInt(slidemenu_reveal))*-1)+'px; position : fixed;top:'+slidemenu_top+'; width:'+slidemenu_width+'" onMouseover="pull()" onMouseout="draw()">')
else if (ns4){
document.write('<style>\n#slidemenubar{\nwidth:'+slidemenu_width+';}\n<\/style>\n')
document.write('<layer id="slidemenubar" left=0 top='+slidemenu_top+' width='+slidemenu_width+' onMouseover="pull()" onMouseout="draw()" visibility=hide>')
}

var sitems=new Array()

///////////Edit below/////////////////////////////////

//siteitems[x]=["Item Text", "Optional URL associated with text"]

sitems[0]=["<div style='text-align:right;'><strong>&lt;&bull;</strong></div>", ""]
sitems[1]=["<big>subfamiles</big>", ""]
sitems[2]=["Buchonomyiinae","#Buchonomyiinae"]
sitems[3]=["Chironominae (Chironomini)", "#ChironominaeChironomini"]
sitems[4]=["Chironominae (Tanytarsini)", "#ChironominaeTanytarsini"]
sitems[5]=["Diamesinae", "#Diamesinae"]
sitems[6]=["Orthocladiinae", "#Orthocladiinae"]
sitems[7]=["Podonominae", "#Podonominae"]
sitems[8]=["Prodiamesinae", "#Prodiamesinae"]
sitems[9]=["Tanypodinae", "#Tanypodinae"]
//If you want the links to load in another frame/window, specify name of target (ie: target="_new")
var target="chirokey_larvae"

/////////////////////////////////////////////////////////

if (ie4||ns4||ns6){
for (i=0;i<sitems.length;i++){
if (sitems[i][1])
document.write('<a href="'+sitems[i][1]+'" target="'+target+'">')
document.write(sitems[i][0])
if (sitems[i][1])
document.write('</a>')
document.write('<br>\n')
}
}

function regenerate(){
window.location.reload()
}
function regenerate2(){
if (ns4){
document.slidemenubar.left=((parseInt(slidemenu_width)-parseInt(slidemenu_reveal))*-1)
document.slidemenubar.visibility="show"
setTimeout("window.onresize=regenerate",400)
}
}
window.onload=regenerate2

rightboundary=0
leftboundary=(parseInt(slidemenu_width)-parseInt(slidemenu_reveal))*-1

if (ie4||ns6){
document.write('</div>')
themenu=(ns6)? document.getElementById("slidemenubar2").style : document.all.slidemenubar2.style
}
else if (ns4){
document.write('</layer>')
themenu=document.layers.slidemenubar
}

function pull(){
if (window.drawit)
clearInterval(drawit)
pullit=setInterval("pullengine()",10)
}
function draw(){
clearInterval(pullit)
drawit=setInterval("drawengine()",10)
}
function pullengine(){
if ((ie4||ns6)&&parseInt(themenu.left)<rightboundary)
themenu.left=parseInt(themenu.left)+10+"px"
else if(ns4&&themenu.left<rightboundary)
themenu.left+=10
else if (window.pullit){
themenu.left=0
clearInterval(pullit)
}
}

function drawengine(){
if ((ie4||ns6)&&parseInt(themenu.left)>leftboundary)
themenu.left=parseInt(themenu.left)-10+"px"
else if(ns4&&themenu.left>leftboundary)
themenu.left-=10
else if (window.drawit){
themenu.left=leftboundary
clearInterval(drawit)
}
}
</script>

<p>See <strong>Sæther, O. A. (1980):</strong> <em>Glossary of chironomid morphology terminology (Diptera: Chironomidae)</em>. Entomologica Scandinavica Supplement. <span style='white-space:nowrap;' > Vol.&nbsp;14, Pp.&nbsp;1&#8211;51.</span> <span onmouseover="return overlib('<div style=\'padding:5px;\'>A glossary divided in parts for imagines, pupae, and larvae, and including synonyms an proposed standardized abbreviations is given. Controversies as to correct terminologies are briefly discussed. Usage of the Tillyard modifications of the Comstock&mdash;Needham&rsquo;s win venationsystem, inferior, superiorand median volsellae is proposed for the imagines. For the larvae the terms paraligula, premandible and mentum are prefered. A list of abbreviations is given and most of the different terms illustrated.</div>', WIDTH, 600, STICKY, MOUSEOFF, CAPTION, 'Abstract (S&aelig;ther 1980)');" onmouseout="return nd();"><img align='middle' src="../structure/img/b_annote.png" width=16 height=16 ></span> Note:&nbsp; ISSN 0105-3574.</p>

<table align="right"  style='border:1px solid;' cellpadding='2' cellspacing='0' summary='Morphology'>

<colgroup>
  <col width="200">
</colgroup>
     <tr>
    <th colspan='2'><a  id="Buchonomyiinae" href='chirokey.php?subfamily_id=7&morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&show=subfamily'>Buchonomyiinae</a></th>
  </tr>
  <tr>
    <td colspan='2' style='text-align:center;'>No images.</td>
  </tr>
  <tr>
    <th colspan='2' ><a id="ChironominaeChironomini" href="chirokey.php?subfamily_id=2&morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&show=subfamily">Chironominae</a><br>Tribus Chironomini
    </th>
  </tr>
  <tr>
    <td>
      <p >head:</p>
      <ol>
        <li>antenna</li>
        <li>mandible</li>
        <li>S-setae (S1 ?)</li>
        <li>premandibles</li>
        <li>mentum teeth</li>
        <li>well developed ventromental plates</li>
        <li>postoccipital plate</li>
      </ol>
    </td>
    <td>
      <div style='text-align:center;'>
        <img src='../doc/img/Chironominae_head.png' width='300' alt='Chironominae head'>
        <br>Head from Chironominae (Tribus Chironomini) (Plank 2006)
      </div>
    </td>
  </tr>
  <tr>
    <td>
      <p >head:</p>
      <ol>
        <li>antenna</li>
        <li>mandibles</li>
        <li>maxillar palp?</li>
        <li>mentum teeth</li>
        <li>well developed ventromental plate (note: the left one can not be seen here)</li>
        <li>submental setae</li>
      </ol>
    </td>
    <td>
      <div style='text-align:center;'>
        <img src='../doc/img/Chironominae_Robackia_demeijerei_head.png' width='300' alt='Chironominae head'>
        <br>Head from Chironominae (Tribus Chironomini) <br><em>Robackia demeijerei</em>(Plank 2006)
      </div>
    </td>
  </tr>
  <tr>
    <td colspan='2'>
      <div style='float:left;'>abdomen:
      <ol>
        <li>head</li>
        <li>anterior (a) and posterior (b) parapods; note: here very long and thin</li>
        <li>anal setae</li>
        <li>supra anal setae</li>
      </ol>
      </div>
      <div style='text-align:center;float:right;padding:10px;'>
        <img src='../doc/img/Chironominae_Robackia_demeijerei_abdomen.png' width='500' alt='Robackia_demeijerei_abdomen'>
        <br>Abdomen from Chironominae (Tribus Chironomini) <br><em>Robackia demeijerei</em>(Plank 2006)
      </div>
    </td>
  </tr>
  <tr>
    <th colspan='2' ><a id="ChironominaeTanytarsini" href="chirokey.php?subfamily_id=2&morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&show=subfamily">Chironominae</a><br>Tribus Tanytarsini
    </th>
  </tr>
  <tr>
    <td colspan='2'>
      <div style='float:left;'>head:
      <ol>
        <li>antenna: a) Lauterborn organs on long pedicells; b) flagellum</li>
        <li>antennal pedestal</li>
        <li>antennal spur</li>
        <li>mentum teeth</li>
        <li>ventromental plates: typical thin and medially close together</li>
        <li>postoccipital plate</li>
        <li>postoccipital margin</li>
      </ol>
      </div>
      <div style='text-align:center;float:right;padding:10px;'>
        <img src='../doc/img/Tanytarsini_head.png' width='500' alt='Tanytarsini (Micropsectra?)'>
        <br>Head from Chironominae (Tribus Tanytarsini) <br><em>Micropsectra? spec.</em>(Plank 2006)</div>
    </td>
  </tr>
  <tr>
    <th colspan='2'><a  id="Diamesinae" href='chirokey.php?subfamily_id=4&morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&show=subfamily'>Diamesinae</a></th>
  </tr>
  <tr><td colspan='2' style='text-align:center;'>Sorry no pictures.</td></tr>
  <tr>
    <th colspan="2"><a id="Orthocladiinae" href="chirokey.php?subfamily_id=3&morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&show=subfamily">Orthocladiinae</a></th>
  </tr>
  <tr>
    <td>
      <p >head:</p>
      <ol>
        <li>antenna</li>
        <li>pecten epipharyngis</li>
        <li>lateral chaetulae?</li>
        <li>premandibles</li>
        <li>mentum teeth</li>
        <li>hidden mandible + hidden maxilla</li>
        <li>(very week) ventromental plates</li>
        <li>postoccipital plate (broken here)</li>
      </ol>
    </td>
    <td>
      <div style='text-align:center;'>
        <img src='../doc/img/Orthocladiinae_head.png' width='300' alt='Orthocladiinae head'>
        <br>Head from Orthocladiinae (Plank 2006)
      </div>
    </td>
  </tr>
  <tr>
    <td>
      <p >mouth region (head):</p>
      <ol>
        <li>antenna</li>
        <li>S-setae (S1)</li>
        <li>pecten epipharyngis</li>
        <li>labral chetae</li>
        <li>premandible</li>
        <li>mentum teeth</li>
        <li>maxillae with a) tiny maxillar palp</li>
        <li>week developed ventromental plate</li>
        <li>submental setae</li>
      </ol>
    </td>
    <td>
      <div style='text-align:center;'>
        <img src='../doc/img/Orthocladiinae2_head.png' width='300' alt='Orthocladiinae head'>
        <br>Mouth region from Orthocladiinae (Plank 2006)
      </div>
    </td>
  </tr>
  <tr>
    <td>
      <p >abdomen:</p>
      <ol>
        <li>head</li>
        <li>a) anterior b) posterior parapods</li>
        <li>anal setae</li>
        <li>procerus</li>
        <li>anal papillae</li>
      </ol>
    </td>
    <td><div style='text-align:center;'><img src='../doc/img/Orthocladiinae_abdomen.png' width='400' alt='Orthocladiinae abdomen'><br>Abdomen from Orthocladiinae (Plank 2006)</div></td>
  </tr>
  <tr>
    <th colspan='2'><a id='Podonominae' href='chirokey.php?subfamily_id=5&morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&show=subfamily'>Podonominae</a>
    </th>
  </tr>
  <tr>
    <td>
      <p >head:<br /></p>
      <ol>
        <li>antenna</li>
        <li>mandible</li>
        <li>teeth of mentum</li>
        <li>large ventromental plates with strong beard</li>
        <li>submental setae</li>
        <li>postoccipital margin</li>
      </ol>
    </td>
    <td>
      <div style='text-align:center;'>
        <img src='../doc/img/Podonominae_head.png' width='300' alt='Podonominae'><br>Head from Podonominae. Strong beard (Plank 2006)
      </div>
    </td>
  </tr>
  <tr>
    <th colspan='2'><a id='Prodiamesinae' href='chirokey.php?subfamily_id=6&morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&show=subfamily'>Prodiamesinae</a></th>
  </tr>
  <tr>
    <td>
      <p >head:</p>
      <ol>
        <li>antenna</li>
        <li>mentum teeth</li>
        <li>strong beard</li>
        <li>submental setae</li>
        <li>postoccipital plate</li>
        <li>postoccipital margin</li>
      </ol>
    </td>
    <td>
      <div style='text-align:center;'>
        <img src='../doc/img/Prodiamesinae_head.png' width='300' alt='Prodiamesinae head'>
        <br>Head from Prodiamesinae (Plank 2006)
      </div>
    </td>
  </tr>
  <tr>
    <td>
      <p >abdomen:</p>
      <ol>
        <li>antenna</li>
        <li>a) anterior and b) posterior parapods </li>
        <li>anal papillae</li>
        <li>procerus (typical: very large!)</li>
        <li>anal setae</li>
      </ol>
    </td>
    <td>
      <div style='text-align:center;'>
        <img src='../doc/img/Prodiamesinae_abdomen.png' width='400' alt='Prodiamesinae larva'>
        <br>Abdomen from Prodiamesinae (Plank 2006)
      </div>
    </td>
  </tr>
  <tr>
    <th colspan="2" ><a id="Tanypodinae" href="chirokey.php?subfamily_id=3&morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&show=subfamily">Tanypodinae</a>
    </th>
  </tr>
  <tr>
    <td>
      <p >head:</p>
      <ol>
        <li>antenna (retractil!)</li>
        <li>maxillar palp</li>
        <li>mentum with inner ligula</li>
        <li>postoccipital margin</li>
      </ol>
    </td>
    <td>
      <div style='text-align:center;'>
        <img src='../doc/img/Tanypodinae2_head.png' width='400' alt='Tanypodinae head'>
        <br>Head from Tanypodinae (Plank 2006)
      </div>
    </td>
  </tr>
  <tr>
    <td>
      <p >head:</p>
      <ol>
        <li>antenna (retractil!)</li>
        <li>maxillar palp</li>
        <li>anterior parapods (it <strong>seems</strong> to be only one)</li>
      </ol>
    </td>
    <td>
      <div style='text-align:center;'>
        <img src='../doc/img/Tanypodinae_head.png' width='400' alt='Tanypodinae head'>
        <br>Head from Tanypodinae (Plank 2006)
      </div>
    </td>
  </tr>
  <tr>
    <td>
      <p >abdomen:</p>
      <ol>
        <li>head with (retractil!) antenna </li>
        <li>a) anterior and b) posterior parapods</li>
      </ol>
    </td>
    <td>
      <div style='text-align:center;'>
        <img src='../doc/img/Tanypodinae_larvae.png' width='400' alt='Tanypodinae head'>
        <br>Head from Tanypodinae (Plank 2006)
      </div>
    </td>
  </tr>
</table>


</div>
</body>
</html>
<?php ?>