<?php
####################################################
#                                                  #
#   ATTENTION: this file is utf8 (unicode)!!       #
#   Converting or save to a different encoding     #
#   can cause damage. Because Greek letters are    #
#   used as variables like phi or theta.           #
#                                                  #
####################################################

/* Array GetImageSize:
(
    [0] => 454
    [1] => 193
    [2] => 2
    [3] => width="454" height="193"
    [bits] => 8
    [channels] => 1
    [mime] => image/jpeg
) */

class  mathuser{// @annotation: CLASS mathuser: start
  function sum_user($array, $fromto="all"){// @annotation: F-sum_user()
    $sum=NULL;
    if(!is_array($array)) {
      echo "No array given in user function sum_user().<br>gettype(array):".gettype($array)."<br> Stop.";
      exit;
    }
    foreach ($array as $key => $value) {
        $sumarray[] = $value;
    }
    $n=$fromto=="all" ? count($array) : $fromto;
    $i = 0;
    $array=$sumarray;
    do  {
      if(gettype($array[$i]) == "integer" || gettype($array[$i]) == "double")
        $sum=$sum+$array[$i];
        $i++;
    }while($i < $n);# end for()
    return $sum;
  }// end F-sum_user()
  function cumsum_user($array, $fromto="all"){// @annotation: F-cumsum_user()
    $sum=array();
    if(!is_array($array)) {
      echo "No array given in user function cumsum_user().<br>gettype(array):".gettype($array)."<br> Stop.";
      exit;
    }
    $n=$fromto=="all" ? count($array) : $fromto;
    $i = 0;
    $value=0;
    do  {
      if(gettype($array[$i]) == "integer" || gettype($array[$i]) == "double")
        $value = $array[$i]+$value;
        $sum[] = $value;
        $i++;
    }while($i < $n);# end for()
    return $sum;
  }// end F-cumsum_user()
  function ave_user($array){// @annotation: F-ave_user()
    if(!is_array($array)) {
      echo "No array given in user function ave_user().<br>gettype(array):".gettype($array)."<br> Stop.";
      exit;
    }
    $ave = self::$this->sum_user($array)/count($array);
    return $ave;
  }// end F-ave_user()
  function arraysToXY_user($X, $Y, $add=0){// @annotation: F-arraysToXY_user()
    if(!is_array($X) || !is_array($Y)) {
      echo "No array given in user function arraysToXY_user().<br> gettype(x): ".gettype($X)."<br> gettype(y): ".gettype($Y)." <br> Stop.";
      exit;
    }
    if(count($X)!=count($Y))
      {echo "Arrays X and Y not equal in user function arraysToXY_user().<br> count(x): ".count($X)."<br> count(y): ".count($Y)." <br> Stop.";exit;}
    foreach ($X as $key => $value) {
      $XY[] = $X[$key]+$add;
      $XY[] = $Y[$key]+$add;
    }
    return $XY;
  }// end F-arraysToXY_user()
  function chainToXY($chain, $debug=false){// @annotation: F-chainToXY()
  /* returns
    array('X')            = coordiantes
    array('Y')
    array('distXY')       = distances between XY
    array('distCumsumXY') = cumulated distances between XY
    array('deltaX')       = delta X
    array('deltaY')       = delta Y
    */
    if(!is_array($chain) ) {
      echo "No array given in user function chainToXY().<br> gettype(chain): ".gettype($chain)."s <br> Stop.";
      exit;
    }
    if(count($chain) < 2 ) {
      echo "Arrays chain must have at least 2 elements in its array in function chainToXY().<br> count(chain): ".count($chain)."<br>Stop.";
      exit;
    }
    if(max($chain) > 8 || min($chain) < 0){
      echo "Chain seems no valid chain code with directions (values of chain max: ".max($chain).", min: ".min($chain)."): <pre>
         3   2   1
           \ | /
         4 - X - 0
           / | \
         5   6   7
      </pre>\n";
    }
    $X = 0; $Y = 0; $XYdist = 0;
//     $chain=array_merge($chain, array($chain[0]));
    foreach ($chain as $key => $value) {
      switch ($value) {// also case "anyString": possible
        case 0: $XY['deltaX'][$key] =  1; $XY['deltaY'][$key] =  0; $XY['distXY'][$key] = 1;
          break;
        case 1: $XY['deltaX'][$key] =  1; $XY['deltaY'][$key] =  1; $XY['distXY'][$key] = sqrt(2);
          break;
        case 2: $XY['deltaX'][$key] =  0; $XY['deltaY'][$key] =  1; $XY['distXY'][$key] = 1;
          break;
        case 3: $XY['deltaX'][$key] = -1; $XY['deltaY'][$key] =  1; $XY['distXY'][$key] = sqrt(2);
          break;
        case 4: $XY['deltaX'][$key] = -1; $XY['deltaY'][$key] =  0; $XY['distXY'][$key] = 1;
          break;
        case 5: $XY['deltaX'][$key] = -1; $XY['deltaY'][$key] = -1; $XY['distXY'][$key] = sqrt(2);
          break;
        case 6: $XY['deltaX'][$key] =  0; $XY['deltaY'][$key] = -1; $XY['distXY'][$key] = 1;
          break;
        case 7: $XY['deltaX'][$key] =  1; $XY['deltaY'][$key] = -1; $XY['distXY'][$key] = sqrt(2);
          break;
      }// end switch
      $XYdist += $XY['distXY'][$key];
      $XY['distCumsumXY'][$key] = $XYdist;
      $X += $XY['deltaX'][$key]; $XY['X'][$key] = $X;
      $Y += $XY['deltaY'][$key]; $XY['Y'][$key] = $Y;
    }// end foreach
    $minX = min($XY['X']);
    $minY = min($XY['Y']);
    array_walk($XY['X'], 'calc_user', '-('.$minX.')');
    array_walk($XY['Y'], 'calc_user', '-('.$minY.')');
// array_walk($y, 'calc_user', -$imparams['cy']);
if($debug){
echo "
<fieldset style='border-color:#FF8C00;'>
<legend style='background-color:#FF8C00;'>Information function chainToXY()</legend>
<pre>
  ######################################
  #    debug information in            #
  #    function   chainToXY()          #
  ######################################
</pre>
";
echo "\n<table style='border:1px solid grey;'>\n";
  echo "\n  <tr>\n";
    echo "\n  <td>\n";
      echo "\nX (for image): \n  <ol class=\"preformatted\" ><li>".implode("</li>\n  <li>",$XY['X'])."</li>\n</ol>";
    echo "\n  </td>\n";
    echo "\n  <td>\n";
      echo "\nY (for image): \n  <ol class=\"preformatted\" ><li>".implode("</li>\n  <li>",$XY['Y'])."</li>\n</ol>";
    echo "\n  </td>\n";
  echo "\n  </tr>\n";
echo "\n</table>\n</fieldset>\n";
}// end debug
    return $XY;
  }// end F-chainToXY()
  function center_user($X){// @annotation: F-center_user()
    if(!is_array($X) ) {
      echo "No array given in user function center_user().<br> gettype(x): ".gettype($X)."s <br> Stop.";
      exit;
    }
    if(count($X) < 2 ) {
      echo "Arrays x must have at least 2 elements in its array in function center_user().<br> count(x): ".count($X)."<br>Stop.";
      exit;
    }

    #$Xave = (max($X)-min($X))/2;
    $Xave = self::ave_user($X);
    foreach ($X as $key => $value) {
      $X[$key] = $X[$key]-$Xave;
    }
    return $X;
  }// end F-center_user()

  function Fourier($input, $isign) {// @annotation: F-Fourier()
    ###################################################################
    # PHP_Fourier 0.03
    # Original Fortran source by Numerical Recipies
    # PHP port by Mathew Binkley (binkleym@nukote.com)
    ###################################################################
    ###################################################################
    # Fourier($data, $sign) - Performs the FFT on the *complex*
    #                         array $data
    #
    # Presumes that count($data) is an integer power of two
    #
    # $data[even] holds the real portion
    # $data[odd] hold the imaginary portion
    #
    # Example: (1 + 2i) ->  $data[0] = 1; $data[1] = 2;
    #
    # $sign = 1  performs the Fourier Transform
    # $sign = -1 performs the Inverse Fourier Transform
    #
    # Use:
    #      $fourier_array = Fourier($inputarray, 1);
    #
    ###################################################################
    #####################################################################
    # We need to shift the array up one because this script is a direct
    # port of the fortran program from NR.  Should fix in future.
    #####################################################################
    $data[0] = 0;
    for ($i = 0; $i < count($input); $i++) $data[($i+1)] = $input[$i];
    $n = count($input);
    $j = 1;
    for ($i = 1; $i < $n; $i += 2) {
      if ($j > $i) {
          list($data[($j+0)], $data[($i+0)]) = array($data[($i+0)], $data[($j+0)]);
          list($data[($j+1)], $data[($i+1)]) = array($data[($i+1)], $data[($j+1)]);
      }
      $m = $n >> 1;
      while (($m >= 2) && ($j > $m)) {
          $j -= $m;
          $m = $m >> 1;
      }
      $j += $m;
    }
    $mmax = 2;
    while ($n > $mmax) {  # Outer loop executed log2(nn) times
      $istep = $mmax << 1;
      $θ = $isign * 2*pi()/$mmax;
      $wtemp = sin(0.5 * $θ);
      $wpr   = -2.0*$wtemp*$wtemp;
      $wpi   = sin($θ);
      $wr = 1.0;
      $wi = 0.0;
      for ($m = 1; $m < $mmax; $m += 2) {  # Here are the two nested inner loops
          for ($i = $m; $i <= $n; $i+= $istep) {
            $j = $i + $mmax;
            $tempr = $wr * $data[$j]     - $wi * $data[($j+1)];
            $tempi = $wr * $data[($j+1)] + $wi * $data[$j];
            $data[$j]     = $data[$i]     - $tempr;
            $data[($j+1)] = $data[($i+1)] - $tempi;
            $data[$i]     += $tempr;
            $data[($i+1)] += $tempi;
          }
          $wtemp = $wr;
          $wr = ($wr * $wpr) - ($wi    * $wpi) + $wr;
          $wi = ($wi * $wpr) + ($wtemp * $wpi) + $wi;
      }
      $mmax = $istep;
    }
    for ($i = 1; $i < count($data); $i++) {
      $data[$i] *= sqrt(2/$n);                   # Normalize the data
      if (abs($data[$i]) < 1E-8) $data[$i] = 0;  # Let's round small numbers to zero
      $input[($i-1)] = $data[$i];                # We need to shift array back (see beginning)
    }
    return $input;
  }// end Fourier()
  function polyXYdistance($X, $Y){//@annotation: F-polyXYdistance()
    if(!is_array($X) || !is_array($Y)) {
      echo "No array given in user function polyXYdistance().<br> gettype(x): ".gettype($X)."<br> gettype(y): ".gettype($Y)." <br>Stop.";
      exit;
    }
    if(count($X) !=count($Y)) {
      echo "Arrays x and y not equal in function polyXYdistance().<br> count(x): ".count($X)."<br> count(y): ".count($Y)." <br>Stop.";
      exit;
    }
    if(count($X) < 2 ) {
      echo "Arrays x and y must have at least 2 elements in their array in function polyXYdistance().<br> count(x): ".count($X)."<br> count(y): ".count($Y)." <br>Stop.";
      exit;
    }
    $dist = array();
    $i = 1;
      do {# mache was
        #echo "i=".pow($X[$i] - $X[$i-1], 2)."+".pow($Y[$i] - $Y[$i-1], 2)."<br>";
        $dist[] = sqrt(pow($X[$i] - $X[$i-1], 2) + pow($Y[$i] - $Y[$i-1], 2));
        $i++;
      }
      while ($i <= count($X));
    return array ( "distances" => $dist, "sum" => self::sum_user($dist));
  }// end F-polyXYdistance()
   function difference($X){//@annotation: F-difference()
    if(!is_array($X)) {
      echo "No array given in user function difference().<br> gettype(x): ".gettype($X)."<br>Stop.";
      exit;
    }
    if(count($X) < 2 ) {
      echo "Arrays x and y must have at least 2 elements in their array in function difference().<br> count(x): ".count($X)."<br>Stop.";
      exit;
    }
    $dist = array();
    $i = 1;
      do {# mache was
        $dist[] = $X[$i] - $X[$i-1];
        $i++;
      }
      while ($i < count($X));
    return array ( "differences" => $dist, "sum" => self::sum_user($dist));
  }// end F-difference()

  function getharmonics($chain, $n, $debug=false)
    # chaindata
    # number of harmonics
    # debug information
  {// @annotation: F-getharmonics()
    if(!is_array($chain) ) {
      echo "No array given in user function getharmonics().<br> gettype(chain): ".gettype($chain)."s <br> Stop.";
      exit;
    }
    if(count($chain) < 2 ) {
      echo "Arrays chain must have at least 2 elements in its array in function getharmonics().<br> count(chain): ".count($chain)."<br>Stop.";
      exit;
    }
    if(max($chain) > 8 || min($chain) < 0){
      echo "Chain seems no valid chain code with directions (values of chain max: ".max($chain).", min: ".min($chain)."): <pre>
         3   2   1
           \ | /
         4 - X - 0
           / | \
         5   6   7
      </pre>\n";
    }
    /* from shape program:  */
    //@annotation: getharmonics(calculate xy from harmonics)
    $chaindata = self::$this->chainToXY($chain,$debug);
//     $nCh = count($chaindata['distCumsumXY']);
     $tp  = $chaindata['distCumsumXY']; // array
     $dT  = $chaindata['distXY']; // array
    $X   = $chaindata['X'];  // array
    $Y   = $chaindata['Y'];  // array
    $dX  = $chaindata['deltaX']; // array
    $dY  = $chaindata['deltaY']; // array
    $T   = end(&$chaindata['distCumsumXY']) ;
    $K   = count($dX);
    if($debug){
    echo  "
<fieldset style='border-color:#FF8C00;'>
<legend style='background-color:#FF8C00;'>Information function getharmonics()</legend>
<pre>
######################################
#    debug information in            #
#    function   getharmonics()       #
######################################
T  = $T (total length)
K  = $K (length)
</pre>\n";
// print_pre($tp);
echo "\n<table style='border:1px solid grey;'>\n";
  echo "\n  <tr>\n";
    echo "\n  <td>\n";
      echo "\ndT (distances of t): \n  <ol class=\"preformatted\" ><li>".implode("</li>\n  <li>",$dT)."</li>\n</ol>";
    echo "\n  </td>\n";
    echo "\n  <td>\n";
      echo "\ntp (cumsum distances of t): \n  <ol class=\"preformatted\" ><li>".implode("</li>\n  <li>",$tp)."</li>\n</ol>";
    echo "\n  </td>\n";
    echo "\n  <td>\n";
      echo "\ndX (delta X): \n  <ol class=\"preformatted\" ><li>".implode("</li>\n  <li>",$dX)."</li>\n</ol>";
    echo "\n  </td>\n";
    echo "\n  <td>\n";
      echo "\ndY (delta Y): \n  <ol class=\"preformatted\" ><li>".implode("</li>\n  <li>",$dY)."</li>\n</ol>";
    echo "\n  </td>\n";
    echo "\n  <td>\n";
      echo "\nX: \n  <ol class=\"preformatted\" ><li>".implode("</li>\n  <li>",$X)."</li>\n</ol>";
    echo "\n  </td>\n";
    echo "\n  <td>\n";
      echo "\nY: \n  <ol class=\"preformatted\" ><li>".implode("</li>\n  <li>",$Y)."</li>\n</ol>";
    echo "\n  </td>\n";
  echo "\n  </tr>\n";
echo "\n</table>\n";
    }
//    print_pre($dT);   print_pre($K);
// print_pre($X);
// print_pre($Y);
//    exit;
    $An = array(); $Bn = array(); $Cn = array(); $Dn = array();
//     echo("Hallo".$dT[0]);
    $dig=ceil(log10($T));
    for ($ni = 1; $ni <= $n; $ni++) {
      $an = $T / (2 * pow($ni, 2) * pow(pi(), 2) );
      $sumsA = array();  $sumsB = array();      $sumsC = array();      $sumsD = array();
      $p = 1;
      if($debug==TRUE && $ni==1) {$digp=ceil(log10($K));echo sprintf("<span style='font-family:  monospace;white-space : pre;background-color: #FFFFFF;'>For each Harmonic number 1...%2$3s run through points 1...%3$".$digp."s:</span><br>\n",$ni, $n,$K);}

      do {#
        $sumsA[$ni] += $dX[$p-1] / $dT[$p-1] * ( cos( 2 * $ni * pi() * $tp[$p-1] / $T) - ( cos( 2 * $ni * pi() * $tp[$p-2] / $T ) ) ) ;
        $sumsB[$ni] += $dX[$p-1] / $dT[$p-1] * ( sin( 2 * $ni * pi() * $tp[$p-1] / $T) - ( sin( 2 * $ni * pi() * $tp[$p-2] / $T ) ) ) ;
        $sumsC[$ni] += $dY[$p-1] / $dT[$p-1] * ( cos( 2 * $ni * pi() * $tp[$p-1] / $T) - ( cos( 2 * $ni * pi() * $tp[$p-2] / $T ) ) ) ;
        $sumsD[$ni] += $dY[$p-1] / $dT[$p-1] * ( sin( 2 * $ni * pi() * $tp[$p-1] / $T) - ( sin( 2 * $ni * pi() * $tp[$p-2] / $T ) ) ) ;
       if($debug==TRUE && $ni==1) echo sprintf("<span style='font-family:  monospace;white-space : pre;background-color: #EEEED1;'>p %1$".$dig."s: dX dY(%2$2s,%3$2s), differences XY: dT(%4$1.3f) and cumsum XY: tp tp-1(%6$".($dig+4).".3f, %5$".($dig+4).".3f)</span><br>\n",$p , $dX[$p-1], $dY[$p-1], $dT[$p-1], $tp[$p-2], $tp[$p-1]);
        $p++;
      }while ($p <= $K);
      $An[$ni] = $an * $sumsA[$ni];
      $Bn[$ni] = $an * $sumsB[$ni];
      $Cn[$ni] = $an * $sumsC[$ni];
      $Dn[$ni] = $an * $sumsD[$ni];
    }# end for()
  if($debug) echo "\n</fieldset>\n";
/**
 *  normalized after Rohlf 1974:
 *  A Comparison of Fourier Methods for the Description of Wing Shape in Mosquitoes (Diptera: Culicidae)
 *  Author(s): F. James Rohlf and James W. Archie
 *  Source: Systematic Zoology, Vol. 33, No. 3 (Sep., 1984), pp. 302-317
 *  Published by: Taylor & Francis, Ltd. for the Society of Systematic Biologists
 *  Stable URL: http://www.jstor.org/stable/2413076
 *
 *   .             .       .     .
 *  | cos(ψ) sin(ψ) |  .  | An Bn |  =
 *  |-sin(ψ) cos(ψ) |     | Cn Dn |
 *   '             '       '     '
 *
 *                   |
 *     Matrix 1·2    |          |An|                          Bn
 *                   |          |Cn|                          Dn
 *                   |          V  V
 *  -----------------+---------------------------------------------------------
 *                   |
 *    -------------->|   _____________________
 *    cos(ψ) sin(ψ)  |  |cos(ψ)*An + sin(ψ)*Cn|      cos(ψ)*Bn + sin(ψ)*Dn
 *    -------------->|   ¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¹¹     ¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯²¹
 *    sin(ψ) cos(ψ)  |  -sin(ψ)*An + cos(ψ)*Cn      -sin(ψ)*Bn + cos(ψ)*Dn
 *                   |   ¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¹²     ¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯²²
 *                                    |                                 |
 *          ·------ ... --------------'------------- ... ---------------'
 *          |
 *          V           |
 *     Matrix (1·2)·3   |       cos(nθ)                                -sin(nθ)
 *                      |       sin(nθ)                                 cos(nθ)
 *  --------------------+-------------------------------------------------------------------------
 *   (.. ₁₁) (.. ₂₁)    | (.. ₁₁)*cos(nθ) + (.. ₂₁)*sin(nθ)      (.. ₁₁)*(-1)*sin(nθ) + (.. ₂₁)*cos(nθ)
 *   (.. ₁₂) (.. ₂₂)    | (.. ₁₂)*cos(nθ) + (.. ₂₂)*sin(nθ)      (.. ₁₂)*(-1)*sin(nθ) + (.. ₂₂)*cos(nθ)
**/
    $aNorm = array(); $bNorm = array(); $cNorm = array(); $dNorm = array();
    $aStar = array(); $bStar = array(); $cStar = array(); $dStar = array();
    for($ni = 1; $ni <= $n; $ni++) {//calculate matrices
        # theta
        $θ[$ni]  =
            0.5 *
              atan(
                2*( $An[$ni]*$Bn[$ni] + $Cn[$ni]*$Dn[$ni] )
                  /
                ( pow($An[$ni], 2) + pow($Cn[$ni], 2) - pow($Bn[$ni], 2) - pow($Dn[$ni], 2) )
              )
          ;
        $aStar[$ni] = ($An[1] *        cos( $θ[$ni] )) + ($Bn[1] * sin( $θ[$ni] ));
        $bStar[$ni] =  $An[1] * (-1) * sin( $θ[$ni] ) + $Bn[1] * cos( $θ[$ni] );
        $cStar[$ni] =  $Cn[1] *        cos( $θ[$ni] ) + $Dn[1] * sin( $θ[$ni] );
        $dStar[$ni] =  $Cn[1] * (-1) * sin( $θ[$ni] ) + $Dn[1] * cos( $θ[$ni] );

      if($ni==1){
        if($aStar[1]==0) print("<span style='color:red;font-size:large;'>Shape seems only one line.</span>");
        $E_Star = sqrt( pow($aStar[1], 2 ) + pow($cStar[1], 2 ) );
        $ψ    =   atan( ($cStar[1] / $aStar[1]) );
      }
      if($debug) {
        echo
          sprintf("<span style='font-family:  monospace;white-space : pre;background-color: #EEEED1;'>θ[ni=%8$".$digp."s]:%1$8.5f ψ=%2$8.5f E*=%3$8.5f <br>  a*=%4$+-10.5e b*=%5$+-10.5e  c*=%6$+-10.5e d*=%7$+-10.5e cos=%9$8.5f sin=%10$8.5f</span><br>\n",
            $θ[$ni] , $ψ, $E_Star, $aStar[1], $bStar[1], $cStar[1], $dStar[1], $ni, cos( $θ[$ni] ), sin( $θ[$ni] )
          );
        echo
          sprintf("<span style='font-family:  monospace;white-space : pre;background-color: #EEEED1;'>  a*=%1$8.5e * %2$8.5e + %3$8.5e * %4$8.5e</span><br>\n",
            $An[1] , cos( $θ[$ni] ) , $Bn[1] , sin( $θ[$ni] )
          );
      }
//       echo "θ[ni]: ".$θ[$ni]." ψ: ".$ψ." E_Star: ".$E_Star.
//       "<br>  aStar:".$aStar[1]." bStar:".$bStar[1]." cStar:".$cStar[1]." dStar:".$dStar[1]."<br>";
      $m12_11 =  cos($ψ)*$An[$ni] + sin($ψ)*$Cn[$ni]; $m12_12 =  cos($ψ)*$Bn[$ni] + sin($ψ)*$Dn[$ni];
      $m12_21 = -sin($ψ)*$An[$ni] + cos($ψ)*$Cn[$ni]; $m12_22 = -sin($ψ)*$Bn[$ni] + cos($ψ)*$Dn[$ni];

      $m23_11 = $m12_11 * cos($ni*$θ[1]) + $m12_12 * sin($ni*$θ[1]);  $m23_12 = $m12_11 * (-1) * sin($ni*$θ[1]) + $m12_12 * cos($ni*$θ[1]);
      $m23_21 = $m12_21 * cos($ni*$θ[1]) + $m12_22 * sin($ni*$θ[1]);  $m23_22 = $m12_21 * (-1) * sin($ni*$θ[1]) + $m12_22 * cos($ni*$θ[1]);

      $aNorm[$ni] = 1 / $E_Star * $m23_11;       $bNorm[$ni] = 1 / $E_Star * $m23_12;
      $cNorm[$ni] = 1 / $E_Star * $m23_21;       $dNorm[$ni] = 1 / $E_Star * $m23_22;
    }// end calculate matrices
    $aNorm[1] = round($aNorm[1], 15);
    return array(
      "notnormalized" => array(
        "a" => $An,
        "b" => $Bn,
        "c" => $Cn,
        "d" => $Dn
        ),
      "normalized" => array(
        "a" => $aNorm,
        "b" => $bNorm,
        "c" => $cNorm,
        "d" => $dNorm
        )
      );
  }// end F-getharmonics()
  function harmonicsToXY($xn, $a, $b, $t, $ord=NULL, $a0=0){// @annotation: F-harmonicsToXY()
      //   #function from rhelp list
      //   # Thomas Petzoldt (Sat 19 Jan 2002 - 23:41:28 EST)
      //   harmonic.simple <- function(x, a0, a, b, t, ord) {
      //     y <- a0
      //     for (p in ord) {
      //       k <- 2 * pi * p * x/t
      //       y <- y + a[p] * cos(k) + b[p] * sin(k)
      //     }
      //     y
      //   }
      //
      // n <- length(nefdf$nefabcd[,1])
      // x <- harmonic.simple(x=1:n,a0=0,a=nefdf$nefabcd[,"a"],b=nefdf$nefabcd[,"b"],n,1:n)#;
      // y <- harmonic.simple(x=1:n,a0=0,a=nefdf$nefabcd[,"c"],b=nefdf$nefabcd[,"d"],n,1:n)#;
    if(!is_array($a) || !is_array($b)) {
      echo "No array given in user function harmonicsToXY().<br> gettype(a): ".gettype($a)."  gettype(b): ".gettype($b)." <br> Stop.";
      exit;
    }
    #array_walk($array, 'calc_user', '-('.$const.')');
    $xn = range(1, $xn);
    $ord = empty($ord) ? $xn : $ord;
    $y = array();
    for($pi=1; $pi<=end($ord); $pi++){
      foreach($xn as $xi => $xv){
       $k =  2 * pi() * $pi/$t * $xv;
      #print_pre($xn);
      #foreach($xn as $ki => $kv){
        $y[$xi] = $y[$xi] + $a0 + $a[$pi] * cos($k) + $b[$pi] * sin($k);
      }// end foreach()
    }// end for()
    return $y;
  }// end F-harmonicsToXY()
}// @annotation:  CLASS mathuser end

class  outline extends mathuser{// @annotation: CLASS outline: start
/**
@annotation: todo ...
**/
  /*
  public - überall zugänglich, lesen, verändern
  protected - innerhalb und in abgeleiteter Klasse
  private - NUR innerhalb Klasse
  */
  public $ArrPosCurrent = array("x" => array(), "y" => array());
  public $ArrPosGoTo    = array("x" => array(), "y" => array());
  public $ArrDirTo      = array();
  public $ArrOutline    = array();
  public $ArrDirMorph   = array("EE","NE","NN","NW","WW","SW","SS","SE");


  ################# @annotation: F-goToPixel($im, $x, $y,$to="SS",$debug=false)
  function goToPixel($im, $x, $y,$to="SS",$CW = true, $debug=false){
        # dir = c(0,1,2,3,4,5,6,7)
        # 3 2 1  directions
        #  \|/
        # 4- -0
        #  /|\
        # 5 6 7
    # $x, $y -> current pixel position
    # xOffset:    1  1  1  0 -1 -1 -1  0
    # yOffset:   -1  0  1  1  1  0 -1 -1
    # direction:   / x- x  x  x  -x \  |
    # direction:  x      \ | /       x x
    switch ($to) {
      case "SS": $direction = array("NN","NE","EE","SE", "SS","SW","WW","NW"); break; #
      case "SW": $direction = array("NE","EE","SE","SS", "SW","WW","NW","NN"); break; #
      case "WW": $direction = array("EE","SE","SS","SW", "WW","NW","NN","NE"); break; #
      case "NW": $direction = array("SE","SS","SW","WW", "NW","NN","NE","EE"); break; #
      case "NN": $direction = array("SS","SW","WW","NW", "NN","NE","EE","SE"); break; #
      case "NE": $direction = array("SW","WW","NW","NN", "NE","EE","SE","SS"); break; #
      case "EE": $direction = array("WW","NW","NN","NE", "EE","SE","SS","SW"); break; #
      case "SE": $direction = array("NW","NN","NE","EE", "SE","SS","SW","WW"); break; #
    }
//     $test=array("NN","NE","EE","SE", "SS","SW","WW","NW");
//     krsort($test);
//     print_pre($test);
    if(is_null($direction)) {
      echo "<span style='color:red;'>Probably only one pixel captured.</span>";
    };
    $CW == true ? $direction : krsort($direction);// is clockwise?
    $direction = array_values($direction);        // remove keys
    #print_pre(is_array($direction));
    #if($debug) {echo "\n<pre>\n";print_r($direction); echo "\n</pre>\n";}

    $dirMorphX = array("EE" => 1,"NE" =>  1,"NN" =>  0,"NW" => -1,"WW" => -1,"SW" => -1,"SS" => 0,"SE" => 1);
    $dirMorphY = array("EE" => 0,"NE" => -1,"NN" => -1,"NW" => -1,"WW" =>  0,"SW" =>  1,"SS" => 1,"SE" => 1);

    $i=0; // Kopfgesteuert
    $colorat = imagecolorat($im, $x, $y);
    while($i < count($direction)){
      # 0, 1, 2, 3, 4, 5, 6, 7,
      $coloratNext = imagecolorat(
        $im,
        ($x+$dirMorphX[$direction[$i]]),
        ($y+$dirMorphY[$direction[$i]])
      );
        //empty($colorat) and
      if($debug)/** @annotation: debug info: goToPixel() **/
        echo  (!is_integer($coloratNext) || $coloratNext > 0) ? $i."w".$direction[$direction[$i]]." " : $i."b".$direction[$direction[$i]]." ";
      if(
         $coloratNext == 0 && is_integer($coloratNext)
        # 0 = empty "" = empty !is_integer($coloratNext) ||
      ) {
        #print($x.$y);
        self::$this->ArrPosCurrent["x"][]=$x;
        self::$this->ArrPosCurrent["y"][]=$y;
        self::$this->ArrDirTo[]=$direction[$i];
        self::$this->ArrPosGoTo["x"][]=($x+$dirMorphX[$direction[$i]]);
        self::$this->ArrPosGoTo["y"][]=($y+$dirMorphY[$direction[$i]]);
        if($debug){/** @annotation: debug info: goToPixel() **/
          echo ":<br>&nbsp;&nbsp;\$colorat: ";
          echo  (is_string($colorat)     || $colorat > 0) ? "w" : "b";
          echo "->";
          echo  (is_string($coloratNext) || $coloratNext > 0) ? "w" : "b";
          echo " from: $from ($x,$y) to:";
          echo " (".($x+$dirMorphX[$direction[$i]]).",".($y+$dirMorphY[$direction[$i]]).") i=".$i." to ".$direction[$i]."<br>\n";
        }# end debug
        break;
      }
      ++$i;# Postincrement
    }
  }// end function goToPixel()

  ################# @annotation: F-imageDrawOutline($im, $prop, $debug=false)
  public function imageDrawOutline ($im, $prop,  $debug=false){
    /* $prop Array from GetImageSize($im)
        (
            [0] => 454
            [1] => 193
            [2] => 2
            [3] => width="454" height="193"
            [bits] => 8
            [channels] => 1
            [mime] => image/jpeg
        ) */
    #imagecopymergegray($im, $im, 0, 0,$prop[1], $prop[2],  $prop[1], $prop[2], 50);
    $px = 0;
    for ($x = 0; $x <= $prop[0]; $x++) {
      for ($y = 0; $y <= $prop[1]; $y++) {
        $color = imagecolorat($im, $x, $y);
        if($debug) echo sprintf('<span style="font-family:monospace;white-space : pre;">x:%1$4s y:%2$4s color: %3$8s</span><br>', $x, $y, $color) ;
        if($color==0 && is_integer($color)) {++$px;break;}
      }# end for($y)
      if($color==0 && is_integer($color)) {break;/* @annotation: stop search at black color */}
    }# end for($x)
    self::goToPixel($im,$x,$y,"SS",$CW=false,$debug);/* @annotation: start goToPixel() */

    do{
      self::goToPixel(
        $im,
        end(self::$this->ArrPosGoTo["x"]),
        end(self::$this->ArrPosGoTo["y"]),
        end(self::$this->ArrDirTo),
        $CW=false,
        $debug
      );

    } while(
      self::$this->ArrPosCurrent["x"][0] != end(self::$this->ArrPosGoTo["x"]) ||
      self::$this->ArrPosCurrent["y"][0] != end(self::$this->ArrPosGoTo["y"]));

  if($debug==true){/** @annotation: debug info: imageDrawOutline() **/
    if(self::$this->ArrPosCurrent["x"][0] != end(self::$this->ArrPosGoTo["x"]) ||
      self::$this->ArrPosCurrent["y"][0] != end(self::$this->ArrPosGoTo["y"]))
      echo "last point is NOT first point";
    else echo "last point is first point";

      echo "<pre>imageDrawOutline() -- current:";
      print_r(self::$this->ArrPosCurrent["x"][0].self::$this->ArrPosCurrent["y"][0]);
      echo "goTo:";
      print_r(end(self::$this->ArrPosGoTo["x"]).end(self::$this->ArrPosGoTo["y"]));
      echo "\n</pre>";
    }# end debug
      self::$this->ArrDirMorph=array_flip(self::$this->ArrDirMorph);
      foreach (self::$this->ArrDirTo as $key => $value) {
        #print_r($value);
        self::$this->ArrOutline[] = self::$this->ArrDirMorph[$value];
      }
    /** @annotation: return outline: imageDrawOutline() **/
    return self::$this->ArrOutline;
  }# end imageDrawOutline()
  function imageOutline($x, $y,  $dst="test.png",$uploaddata='', $padding=8, $debug=false){// @annotation: F-imageOutline()
  // output outlined image
    $nx=count($x);
    $maxX = max($x);$maxY = max($y);
    $minX = min($x);$minY = min($y);
    $width  = ($maxX-$minX)+$padding;
    $height = ($maxY-$minY)+$padding;
  /** note in image  (0,0) is top left!! **/
  $imOut = imagecreatetruecolor($width,$height);
  // Allocate a color for the polygon
   $red =  imagecolorallocate($imOut, 255, 0, 0);
  $blue =  imagecolorallocate($imOut,  0, 0 ,255);
  $white = imagecolorallocate($imOut, 255, 255, 255);
  $aquamarin = imagecolorallocate($imOut, 123, 255, 213);
if($debug){
echo "
<fieldset style='border-color:#FF8C00;'>
<legend style='background-color:#FF8C00;'>Information function imageOutline(x, y, dst, padding=8, debug)</legend>
<p>Note: in images the coordiante xy(0,0) is top left!</p>
";
}
  foreach($x as $key => $value){
    $xim[$key] = $x[$key];//abs($x[$key] - $maxX);
    $yim[$key] = abs($y[$key] - $maxY);
    if($debug) echo sprintf("<span style='font-family:  monospace;white-space : pre;background-color: #EEEED1;'> index (%1$3d): x-y (%2$7.3f, %3$7.3f) ->  x-y (%4$7.3f,%5$7.3f)</span><br>\n",$key , $x[$key], $y[$key], $xim[$key], $yim[$key]);
    #echo " $key x-y: ".$x[$key]."-".$y[$key]." -> ".$xim[$key]."-".$yim[$key]."\n";
  }
echo $debug ? "\n</fieldset>\n":"";
  $xy=parent::arraysToXY_user($xim, $yim, $padding/2);
           imagefilledpolygon($imOut, $xy, $nx, $white);
    for($xp=0,$area=0; $xp<=$width; $xp++){/* @annotation: calculate areapx */
      #echo $xp;
      for($yp=0; $yp<=$height; $yp++){
        #echo $yp;
        $area+=imagecolorat($imOut, $xp, $yp) > 0 ? 1 : 0;  // add 1 if colorindex > 0
        #echo imagecolorat($imOut, $xp, $yp)." ";
        //if($i > 5) break;
      }// end for()
      //if($i > 5) break;
    }// end for()
    for($i=1, $cx=0, $cy; $i<$nx; $i++){/* @annotation: calculate centroids */
      $cx += ($x[$i] + $x[$i+1]) * ($x[$i] * $y[$i+1] - $x[$i+1] * $y[$i]);
      $cy += ($y[$i] + $y[$i+1]) * ($x[$i] * $y[$i+1] - $x[$i+1] * $y[$i]);
      //if($i > 5) break;
    }// end for()
    $cx = $cx * 1/(6 * $area);$cy = $cy * 1/(6 * $area);
    $cXorig = abs(abs($cx)-$maxX);
    $cYorig = abs(abs($cy));
    $cx = abs(abs($cx) + ($padding/2));
    $cy = abs(abs($cy) + ($padding/2));
    imagepolygon($imOut, $xy, $nx, $red);# draw outline
    ## centroid
    imageline($imOut, $cx-3, $cy-3, $cx+3 , $cy + 3, $red);
    imageline($imOut, $cx-3, $cy+3, $cx+3 , $cy - 3, $red);
    ## starting point
    imagearc($imOut, $xim[0]+$padding/2, $yim[0]+$padding/2, 8, 8,  0, 360, $blue);
    imagearc($imOut, $xim[0]+$padding/2, $yim[0]+$padding/2, 6, 6,  0, 360, $blue);
    imagepng($imOut, $dst, 9);
    imagedestroy($imOut);
    $textadd=empty($uploaddata)?"":" (".(is_array($uploaddata)? $uploaddata['name']:$uploaddata).")";
    echo "\n<img  src=\"$dst\" width=\"$width\"  height=\"$height\" title=\"'".$dst."': output image from contour".$textadd." with starting point and centroid\" alt=\"".$dst.": output image from contour\" >";
    return array(
      "areapx" => $area,
      "cx" => $cXorig,
      "cy" => $cYorig,
      "note" => "['areapx']: area in px; centroids ['cx'] and ['cy'] have no padding values (".($padding/2)."px). These values are given as usually for a Cartesian coordinate system."
    );
  }// end imageOutlineCentroid of polygon

    function loadedImageFromFile($file){// @annotation: F-loadedImageFromFile()
    $size = GetImageSize($file);
    switch ($size['mime']) {
      case  'image/bmp':
        $im = @imagecreatefromwbmp($file);
        break;
      case "image/jpeg":
        $im = @imagecreatefromjpeg($file);
        break;
      case "image/gif":
        $im = @imagecreatefromgif($file);
        break;
      case "image/png":
        $im = @imagecreatefrompng($file);
        break;
    }
    if ($im == "") { /* See if it failed */
      #$im = ImageCreate($size[0],$size[1]); /* Create a blank image */
      #$bgc = ImageColorAllocate($im,0,255,255);
      #$tc  = ImageColorAllocate($im,0,0,0);
      #ImageFilledRectangle($im,20,20,150,30,$bgc);
      #ImageString($im,1,5,5,"Error loading ".$file."\n".$size['mime'],$tc); /* Output an errmsg */
      echo "Error loading '".$file."' with mime type: '".$size['mime']."' in function loadedImageFromFile(class outline)";
      exit;
    }
    return $im;
  }// end F-loadedImageFromFile
  function imagecreatefromfile($path, $user_functions = false){//@annotation: F-imagecreatefromfile()
    function ImageCreateFromBMP($filename){// @annotation: ImageCreateFromBMP
      /*********************************************/
      /* Fonction: ImageCreateFromBMP              */
      /* Author:   DHKold                          */
      /* Contact:  admin@dhkold.com                */
      /* Date:     The 15th of June 2005           */
      /* Version:  2.0B                            */
      /*********************************************/
    //Ouverture du fichier en mode binaire
      if (! $f1 = fopen($filename,"rb")) return FALSE;

    //1 : Chargement des entêtes FICHIER
      $FILE = unpack("vfile_type/Vfile_size/Vreserved/Vbitmap_offset", fread($f1,14));
      if ($FILE['file_type'] != 19778) return FALSE;

    //2 : Chargement des entêtes BMP
      $BMP = unpack('Vheader_size/Vwidth/Vheight/vplanes/vbits_per_pixel'.
                    '/Vcompression/Vsize_bitmap/Vhoriz_resolution'.
                    '/Vvert_resolution/Vcolors_used/Vcolors_important', fread($f1,40));
      $BMP['colors'] = pow(2,$BMP['bits_per_pixel']);
      if ($BMP['size_bitmap'] == 0) $BMP['size_bitmap'] = $FILE['file_size'] - $FILE['bitmap_offset'];
      $BMP['bytes_per_pixel'] = $BMP['bits_per_pixel']/8;
      $BMP['bytes_per_pixel2'] = ceil($BMP['bytes_per_pixel']);
      $BMP['decal'] = ($BMP['width']*$BMP['bytes_per_pixel']/4);
      $BMP['decal'] -= floor($BMP['width']*$BMP['bytes_per_pixel']/4);
      $BMP['decal'] = 4-(4*$BMP['decal']);
      if ($BMP['decal'] == 4) $BMP['decal'] = 0;

    //3 : Chargement des couleurs de la palette
      $PALETTE = array();
      if ($BMP['colors'] < 16777216)
      {
        $PALETTE = unpack('V'.$BMP['colors'], fread($f1,$BMP['colors']*4));
      }

    //4 : Création de l'image
      $IMG = fread($f1,$BMP['size_bitmap']);
      $VIDE = chr(0);

      $res = imagecreatetruecolor($BMP['width'],$BMP['height']);
      $P = 0;
      $Y = $BMP['height']-1;
      while ($Y >= 0)
      {
        $X=0;
        while ($X < $BMP['width'])
        {
        if ($BMP['bits_per_pixel'] == 24)
            $COLOR = unpack("V",substr($IMG,$P,3).$VIDE);
        elseif ($BMP['bits_per_pixel'] == 16)
        {
            $COLOR = unpack("n",substr($IMG,$P,2));
            $COLOR[1] = $PALETTE[$COLOR[1]+1];
        }
        elseif ($BMP['bits_per_pixel'] == 8)
        {
            $COLOR = unpack("n",$VIDE.substr($IMG,$P,1));
            $COLOR[1] = $PALETTE[$COLOR[1]+1];
        }
        elseif ($BMP['bits_per_pixel'] == 4)
        {
            $COLOR = unpack("n",$VIDE.substr($IMG,floor($P),1));
            if (($P*2)%2 == 0) $COLOR[1] = ($COLOR[1] >> 4) ; else $COLOR[1] = ($COLOR[1] & 0x0F);
            $COLOR[1] = $PALETTE[$COLOR[1]+1];
        }
        elseif ($BMP['bits_per_pixel'] == 1)
        {
            $COLOR = unpack("n",$VIDE.substr($IMG,floor($P),1));
            if     (($P*8)%8 == 0) $COLOR[1] =  $COLOR[1]        >>7;
            elseif (($P*8)%8 == 1) $COLOR[1] = ($COLOR[1] & 0x40)>>6;
            elseif (($P*8)%8 == 2) $COLOR[1] = ($COLOR[1] & 0x20)>>5;
            elseif (($P*8)%8 == 3) $COLOR[1] = ($COLOR[1] & 0x10)>>4;
            elseif (($P*8)%8 == 4) $COLOR[1] = ($COLOR[1] & 0x8)>>3;
            elseif (($P*8)%8 == 5) $COLOR[1] = ($COLOR[1] & 0x4)>>2;
            elseif (($P*8)%8 == 6) $COLOR[1] = ($COLOR[1] & 0x2)>>1;
            elseif (($P*8)%8 == 7) $COLOR[1] = ($COLOR[1] & 0x1);
            $COLOR[1] = $PALETTE[$COLOR[1]+1];
        }
        else
            return FALSE;
        imagesetpixel($res,$X,$Y,$COLOR[1]);
        $X++;
        $P += $BMP['bytes_per_pixel'];
        }
        $Y--;
        $P+=$BMP['decal'];
      }

    //Fermeture du fichier
      fclose($f1);

    return $res;
    }// end ImageCreateFromBMP
    $info = @getimagesize($path);
    if(!$info)
      return false;

    $functions = array(
        IMAGETYPE_GIF => 'imagecreatefromgif',
        IMAGETYPE_JPEG => 'imagecreatefromjpeg',
        IMAGETYPE_PNG => 'imagecreatefrompng',
        IMAGETYPE_WBMP => 'imagecreatefromwbmp',
        IMAGETYPE_XBM => 'imagecreatefromwxbm',
        );

    if($user_functions) $functions[IMAGETYPE_BMP] = 'imagecreatefrombmp';

    if(!$functions[$info[2]]) return false;

    if(!function_exists($functions[$info[2]])) return false;

    return $functions[$info[2]]($path);
  }// end imagecreatefromfile
}// @annotation: CLASS outline: end





   ?>

