<?php
/**
 * Update of references
 *
 * Editing and updating of references and for creating new ones. Some input fields use
 * AJAX to check, if data are alredy in the database and to get for instance same journal names or
 * authors' names.
 * @author Andreas Plank <andreas.plank@web.de>
 * @version 2009-02-24 21:24:33
 * @package chirokey_pupae
 * @subpackage references
 */

/**
 * Extract current server path relatively
 *
 * {1} is 1 level up
 * @global string $currentServerPath
 */
$currentServerPath = preg_replace('#(.+/)([^/]+/){1}[^/]+\.php#',"\\1\\3", __FILE__);
include($currentServerPath.'structure/session.inc.php');
header('content-type: text/html; charset=utf-8');
header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past
header ("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT"); // always modified
header ("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
header ("Pragma: no-cache"); // HTTP/1.0
include($currentServerPath.'structure/functions.php');
include($currentServerPath.'structure/classes/sql.php');//first get classes
include($currentServerPath.'structure/config.php');/* login */
include($currentServerPath.'structure/classes/tools.php');

/**
 * make classes db_mysql, html, formreload available
 */
$objMysql = new db_mysql;//class db_mysql
$objHtml  = new html;//class html
$reload   = new formreload;
// docSimple

/**
 * some title HTML-page settings, links, skripts
 */
  $title = 'Update '.$_GET['title'];
  $link = '../structure/css/basic.css';
  $javascript = 'src="../structure/js/functions.js"';
  $scriptafter = "<style type='text/css'>
  table input, table textarea,table  select{
    min-width:500px;
  }
</style>";
# @annotation autoSuggestion AJAX-scripts
  /**
  * autoSuggestion
  *
  * AJAX
  * @global string $srcipt
  */
  $script = "  <script type=\"text/javascript\" src=\"../structure/js/bsn.AutoSuggest_2.1.3_comp.js\" charset=\"utf-8\"></script>";
    $script.= "\n".'<link rel="stylesheet" href="../structure/css/autosuggest_inquisitor.css" media="screen" type="text/css">';
/**
 * include creating page header
 */
   include($currentServerPath.'structure/pages.php');
/**
  * put page together
  */
   $content = $page['head'];
//   $content = isset($page['head']) ?  "head" :  "nohead";
//   echo $content.$page['head'];
//    var_dump($page['head']);
// $content.=print_r($_POST,true);
// $content.=print_r($_GET,true);

# @annotation: get all keywords for the form
if($dbKeywordsAll=$objMysql->queryObjectArray("SELECT `keywords` FROM `names_authors` WHERE `keywords` IS NOT NULL AND `keywords` NOT LIKE \"\";")){
    $arrTmp = array();
    $i=0;
    foreach ($dbKeywordsAll as $kwdvalue) {
      $arrKwd = ($i==0)? preg_split("/\s*,[\n\r]*\s*/", $kwdvalue->keywords) : array_merge($arrKwd, preg_split("/\s*,[\n\r]*\s*/", $kwdvalue->keywords));
      $i++;
    }// end foreach
    natcasesort($arrKwd);
    $arrKwd=array_count_values($arrKwd);
  }// fetch all keywords
  foreach ($arrKwd as $key => $value) {
    $SelectKeywords[$key] = empty($key)? "^^ add a selected keyword ^^" : $key." (".$value.")";
  }// end foreach

# @annotation: update references (prepare data)
if($_GET['title']=="references" &&
  $_GET["refid"] &&
  !empty($page['head'])
  ){#htmlentities($value,ENT_QUOTES,'UTF-8')
  if($_POST["update"]==1) {//update==1 from table
  # @annotation: update references: replace difficult characters
    $_POST['abstract'] = replaceHTMLcode($_POST['abstract']);
  # @annotation: UPDATE only: prepare keywords (alphabetically)
    $_POST['keywords'] = user_sortwords($_POST['keywords']);
  # check if year is missing in shortauthor
    $intYear = (string)preg_replace("#^[^0-9]+(.{4})$#", "\\1",$_POST["authors_short"]);
    if(!is_numeric(preg_split("/./",$intYear))){
      $_POST["authors_short"] = preg_replace(
        "# +#", " ",
        preg_replace("/(.+)\s*[0-9]+\s*$/U", "\\1",$_POST["authors_short"])." ".$_POST["year"]
      );
    }
    if($intYear==0)
      $_POST["authors_short"] = preg_replace("/(.+)\s*0\s*$/U", "\\1 n.d.",$_POST["authors_short"]);
//     print_r($_POST);
    foreach ($_POST as $key => $value){
      $tmp[$key] = empty($value)  ? "NULL" : "'".addslashes($value)."'";

      # add NULL
      // echo "POST gesetzt";
    }
    $_POST = $tmp;unset($tmp);
//     print_r($tmp);exit;
/**
 * performe MySQL INSERT
 */

    if(# @annotation: INSERT
      $_GET['refid']=='new' &&
      !empty($_POST['authors_short']) &&
      !empty($_POST['author_names']) &&
      !empty($_POST['year']) #&&
      //$reload->easycheck_empty()
      ){#
        # @annotation: INSERT: remove all special non-letters + and
          $search          = array("/[^and]and[^and]/","/\s*/","/[^\w]*\d*/");
          $replace         = array("","","");
          $author_filename = htmlentities($_POST["author_names"],ENT_QUOTES,'UTF-8');# æ -> &aelig; etc.
          $year=str_replace("'","",$_POST["year"]);
          $author_filename = preg_replace($search,$replace,$author_filename);
          $author_filename = substr($author_filename,0,3).$year;
        # sort keywords alphabetically
          $_POST['keywords'] = user_sortwords($_POST['keywords']);
        # add letter to author_filename if needed
          $i=0; $abc = explode(" "," a b c d e f g h i j k l m n o p q r s t u v w x y z");
          # Array ( [0] => [1] => a [2] => b [3] => c [4] => d...)
          while ($test_author_filename=$objMysql->querySingleItem("SELECT `author_filename` FROM `names_authors` WHERE `author_filename` LIKE '%".$author_filename.$abc[$i]."%';")!=-1){
            $i++;
            #break;
          }
        # compose filename
          $author_filename = $author_filename.$abc[$i];
        # INSERT
        include($currentServerPath.'structure/config.php');/* login */
        #echo "test_author_filename:".$test_author_filename."InsertNewReference:<br>".$MysqlInsert['NewReference'];
          if($objMysql->execute($MysqlInsert['NewReference'])){
            $refid=$objMysql->insertId();
          }
          // @annotation: UPDATE literal
          $objMysql->execute($MysqlUpdate['ReferenceLiteral']);
          // redirect to the new reference
          header("Location: http://".$_SERVER['SERVER_NAME']."/".$config['ServerRootDir'].$config['ServerKeyDir']."update.php?title=references&refid=".$refid);
          # $_GET['refid'] = $refid;
          unset($test_author_filename);
        #unset($_POST);
    }# end INSERT
    elseif(# @annotation: UPDATE only
      is_numeric($_GET['refid']) &&
      !empty($_POST['authors_short']) &&
      !empty($_POST['author_names']) &&
      !empty($_POST['year'])){
       //echo "UpdateReference".$MysqlUpdate['Reference'];
      include($currentServerPath.'structure/config.php');/* login */
        $objMysql->execute($MysqlUpdate['Reference']);
        // @annotation: UPDATE literal
        $objMysql->execute($MysqlUpdate['ReferenceLiteral']);
        $refid = $_GET['refid'];
          header("Location: http://".$_SERVER['SERVER_NAME']."/".$config['ServerRootDir'].$config['ServerKeyDir']."update.php?title=references&refid=".$refid);
          exit;
        // print_r($_POST);
        // unset($_POST);
    }# end UPDATE
    elseif(# something is empty
          empty($_POST['authors_short']) ||
          empty($_POST['author_names']) ||
          empty($_POST['year'])
      ){
      $message = empty($_POST['authors_short']) ? ' authors_short,' : '';
      $message.= empty($_POST['author_names']) ? ' author_names,' : '';
      $message.= empty($_POST['year']) ? ' year,' : '';
      $message = substr($message,0, strlen($message)-1);
      $message = "\n  <fieldset class='info'><legend>Info</legend>Field(s) emty:".$message.".</fieldset>\n";
    }
      unset($_POST);
  }// end update = 1
  elseif(// @annotation: delete
    isset($_POST['delete']) &&
    $_POST['references_id']!='new'
  ){
    $objMysql->execute("
    DELETE FROM `names_authors`
      WHERE `names_authors`.`id` = ".$_POST['references_id']."
      LIMIT 1;");
    // @annotation: UPDATE literal
    $objMysql->execute($MysqlUpdate['ReferenceLiteral']);
    header("Location: http://".$_SERVER['SERVER_NAME']."/".$config['ServerRootDir'].$config['ServerKeyDir']."update.php?title=references&refid=new");
    exit;
  }

  unset($result,$resultb);
  if($_GET['refid']!='new'){ # @annotation: references
    if($result=$objMysql->queryObjectArray("SELECT * FROM `names_authors` WHERE `id` = ".$_GET['refid'].""))
    $refid=$_GET['refid'];
  }
  else {// not new
    if($result=$objMysql->queryObjectArray("SELECT * FROM `names_authors` LIMIT 1"))
      foreach ($result[0] as $key => $value) {
        $tmp[$key]="";
      }
      $result[0]=$tmp;
  }
  if($resultb=$objMysql->queryObjectArray("SHOW FULL COLUMNS FROM `names_authors`")){
    // @annotation: reference
    if($resultRef=$objMysql->queryObjectArray($MysqlSelect['ReferencesReplace'])){
      foreach($resultRef as $value)
        $Select[$value->id]=$value->authors_short;
    }
  }
  # @annotation: compose selections
  $default        = array("new" => "new reference (or select)");
  $Select         = $default + $Select;
  $default = $_GET['refid']!="new" ? $Select[$_GET['refid']] : 'new reference (or select)';
    $HTMLelement = $objHtml->select($Select,"refid",$default,"style='width:300px;' title='reference authors'");
    $selection =$HTMLelement."&nbsp;";
    $refid = $_GET['refid'];
    $default = "^^ select a reference as string for notes ^^";
    #array_splice($Select, 0,1,array($default));
    $Select['new'] = $default;
    $SelectRefNotes = $objHtml->select($Select,"note_reference",$default,"style='width:300px;' title='reference authors for note' onchange=\"javascript:insert('{textciteID|' + this.options[selectedIndex].value+'|'+this.options[selectedIndex].text+'}','','referencesform','note');\" ");
    $SelectKeywords = $objHtml->select($SelectKeywords,"add_keywords","^^ add a selected keyword  ^^", "style='width:300px;' size='10' title='keywords in the database' onchange=\"javascript:insert('' + (document.referencesform.keywords.value==''? '' : ', ') + this.options[selectedIndex].value + '','','referencesform','keywords');\" ");

  unset($resultRef,$Select);

/**
 * create form for references
 */
    $body.="<fieldset class='infosimple'><legend>Edit/Add References</legend>";
    $body.="\n<form name='".$_GET['title']."' action='http://".$_SERVER['SERVER_NAME']."/".$config['ServerRootDir'].$config['ServerKeyDir']."update.php?' method='get'>\n";
    $body.=$selection;
    $body.="<input type='hidden' value='references' name='title'>\n";
    $body.="<input type='submit'  value='view' >\n<br>";
    $body.="\n</form>\n";
    $body.="\n<form name='".$_GET['title']."' action='http://".$_SERVER['SERVER_NAME']."/".$config['ServerRootDir'].$config['ServerKeyDir']."update.php?title=references&refid=new' method='post'>\n";
//     $body.=print_r($_GET,true);
    $body.="
    <ul style='text-align:left;'>
      <li>To add a new reference select the first option «new reference (or select)» and press «view».</li>";
    $body.= $_GET["refid"]=='new' ?"" : "<li>Deleting can be done manually as well in the table «names_authors» by click <a href='http://localhost/".$config['phpmyadminpath']."/sql.php?db=chirokey_pupae&table=names_authors&sql_query=SELECT+%2A+FROM+%60names_authors%60+WHERE+%60names_authors%60.%60id%60+%3D+".$refid."+LIMIT+1&zero_rows=The+row+has+been+deleted&goto=sql.php%3Fdb%3Dchirokey_pupae%26table%3Dnames_authors%26token%3Da7355704ecb893c83e4c2837cf1fa563%26sql_query%3DSELECT%2B%252A%2B%2BFROM%2B%2560names_authors%2560%2BWHERE%2B%2560id%2560%2B%253D%2B310%26zero_rows%3DThe%2Brow%2Bhas%2Bbeen%2Bdeleted%26goto%3Dtbl_sql.php' target='_blank' class='external'>MySQL-Database</a> and delete dataset with ID ".$refid.". After deleting, refresh this site and click save button again to get the correct literal-letters for each reference.<li>";
    $body.="</ul>\n";
    $body.="<input type='hidden' value='".$refid."' name='references_id'>\n";
    $body.= $_GET["refid"]=='new' ?"" : "<button title=\"delete current dataset\" type=\"submit\" onclick=\"check=confirm('Do you really want to do delete dataset ".$refid." in table `names_authors`?\\nThere is no way back!');if (check==false) return false;\" name=\"delete\">\n  <img src='../structure/img/b_drop.png' align='middle' width='16' height='16' > Delete\n";
    $body.="</button>";
    $body.="\n</form>\n";
    // prevent pressing enter before neccesary fields are filled
    $body.="\n<form name='".$_GET['title']."form' onsubmit='if(document.getElementById(\"authors_short\").value ==\"\" || document.getElementById(\"year\").value ==\"\" || document.getElementById(\"author_names\").value ==\"\") return false;' action='http://".$_SERVER['SERVER_NAME']."/".$config['ServerRootDir'].$config['ServerKeyDir']."update.php?title=references&refid=".$refid."' method='post'>\n";
    // $body.="\n<form name='".$_GET['title']."form'  action='".$_SERVER['REQUEST_URI']."' method='post'>\n";
    $body.="<input type=\"hidden\" id=\"ajaxvalues\" value=\"\"  >";
    $body.=$reload->get_formtoken(); # input field prevent from reload
    $body.="\n<br>\n <div style='text-align:center;'>Fields marked with * are neccesary.</div>\n  <table align='center' style='border:solid 1px;'>\n";
    $structure=array(
      'author_filename' => ' disabled class="disabled" ',
      'author_names' => ' onkeypress="return checkEnter();" ',
      'authors_short' => ' onkeypress="return checkEnter();" ',
      'editor_name' => ' onkeypress="return checkEnter();" ',
      'id' => ' disabled class="disabled" ',
      'journal' => ' onkeypress="return checkEnter();" ',
      'literal' => ' disabled class="disabled" ',
      'publisher_name' => ' onkeypress="return checkEnter();" ',
      'year' => ' onkeypress="return checkEnter();" ',
      );
    $inputAdds=array(
      'note' => $SelectRefNotes,
      'keywords' => $SelectKeywords
      );
//       $content.=print_pre($SelectRefNotes, true);
/**
 * print table
 */
    $body.=call_user_func('tabprint',$result,$resultb,$structure, $inputAdds);
    $body.="\n  </table>\n";
    $body.="\n</form>\n</fieldset>\n";
/**
 * print BibTeX output
 */
  if($_GET['refid']!='new'){ # @annotation: BibTeX output
  $result=&get_object_vars($result[0]);
  // general replacements
    $search = array(
      "# & #",
      "#<em>#",
      "#(</em>|<em/>)#"
    );
    $replace = array(
      " \& ",
      "\\textit{",
      "}"
    );
    $result['title'] = preg_replace($search, $replace, $result['title']);
    $result['journal'] = preg_replace($search, $replace, $result['journal']);
    $result['publisher_name'] = preg_replace($search, $replace, $result['publisher_name']);
    $body.="<fieldset>\n  <legend>BibTeX output</legend>\n";
    $body.="\n  <p>I recommend to use the LaTeX package biblatex. Copy the text below into a *.bib file and run it with bibtex.exe. See <a href='http://www.bibtex.org/' class='external' target='_blank'>http://www.bibtex.org</a>. For organizing literature see also <a href='http://www.zotero.org/' target='_blank' class='external'>http://www.zotero.org/</a> a free Firefox plugin for organizing literature.</p>\n";
    // BibTeX start; BibTeX entry_type
    $body.="<span class='BibTeXentrytype' >@".(preg_grep("/^no/", $result)?"article":$result['entry_type'])."</span>";
    $body.="<span class='paranthesis1' >{</span>"; // BibTeX start
    // BibTeX ID-Key
      $body.="<span class='BibTeXID'><acronym title='BibTeX ID key (should be unique)' >".preg_replace(
        array("/\band\b/","/\bet\.?\s*al\./","/\s+/", "/\./"),
        array("And","EtAl","",""),
        trim($result['authors_short'].$result['literal'])
      )."</acronym></span>,<br>\n";
    # authors, e.g. author={Pinder, L. C. V. and Reiss, F.},
      $body.="&nbsp;&nbsp;<span class='bibentry' >author</span> = <span class='paranthesis2' >{</span>".preg_replace("/(\.\s*),/", "\\1 and ",$result['author_names'])."<span class='paranthesis2' >}</span>,<br>\n";
    # shortauthor, see biblatex package
      $body.="&nbsp;&nbsp;<span class='bibentry' >shortauthor</span> = <span class='paranthesis2' >{{</span>".preg_replace("/(.+)\s*[0-9]+$/U", "\\1",$result['authors_short'])."<span class='paranthesis2' >}}</span>,<br>\n";
    # address
      $body.=(empty($result['author_address'])&&empty($result['author_mail']))?"":"&nbsp;&nbsp;<span class='bibentry' >address</span> = <span class='paranthesis2' >{</span>".$result['author_mail']."; ".$result['author_address']."<span class='paranthesis2' >}</span>,<br>\n";
    # title={{The pupae of Chironominae (Diptera: Chironomidae) of the Holarctic region.}},
      $body.="&nbsp;&nbsp;<span class='bibentry' >title</span> = <span class='paranthesis2' >{{</span>".$result['title']."<span class='paranthesis2' >}}</span>,<br>\n";
    # year={1983},
      $body.="&nbsp;&nbsp;<span class='bibentry' >year</span> = <span class='paranthesis2' >{</span>".$result['year']."<span class='paranthesis2' >}</span>,<br>\n";
    # pages={293 - 436},
      $body.=empty($result['page'])?"":"&nbsp;&nbsp;<span class='bibentry' >pages</span> = <span class='paranthesis2' >{</span>".$result['page']."<span class='paranthesis2' >}</span>,<br>\n";
    # volume={19},
      $body.=empty($result['volume'])?"":"&nbsp;&nbsp;<span class='bibentry' >volume</span> = <span class='paranthesis2' >{</span>".$result['volume']."<span class='paranthesis2' >}</span>,<br>\n";
    # number={},
      $body.=empty($result['number'])?"":"&nbsp;&nbsp;<span class='bibentry' >number</span> = <span class='paranthesis2' >{</span>".$result['number']."<span class='paranthesis2' >}</span>,<br>\n";
    # month={},
      $body.=empty($result['month'])?"":"&nbsp;&nbsp;<span class='bibentry' >month</span> = ".preg_replace(
        array(
          "#.*(jan).*#i",
          "#.*(feb).*#i",
          "#.*(mar).*#i",
          "#.*(apr).*#i",
          "#.*(may).*#i",
          "#.*(jun).*#i",
          "#.*(jul).*#i",
          "#.*(aug).*#i",
          "#.*(sep).*#i",
          "#.*(oct).*#i",
          "#.*(nov).*#i",
          "#.*(dec).*#i"
        ),
        array( "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12" ),
        $result['month']
      ).",<br>\n";
      #$body.=empty($result['month'])?"":"&nbsp;&nbsp;month = ".strtolower(substr($result['month'],0,3)).",<br>\n";
    // series={Entomologica Scandinavica Supplement},
      switch ($result['entry_type']) {
        case "no entry type given":
          $body.="&nbsp;&nbsp;<span class='bibentry' >journal</span> = <span class='paranthesis2' >{</span>".$result['journal']."<span class='paranthesis2' >}</span>,<br>\n";  break;
        case "article" :
          $body.="&nbsp;&nbsp;<span class='bibentry' >journal</span> = <span class='paranthesis2' >{</span>".$result['journal']."<span class='paranthesis2' >}</span>,<br>\n";  break;
        case "book":
          $body.="&nbsp;&nbsp;<span class='bibentry' >series</span> = <span class='paranthesis2' >{</span>".$result['journal']."<span class='paranthesis2' >}</span>,<br>\n";
          $body.="&nbsp;&nbsp;<span class='bibentry' >edition</span> = <span class='paranthesis2' >{</span>".$result['edition']."<span class='paranthesis2' >}</span>,<br>\n";
          // editor e.g. editor={T. Wiederholm},
          $body.="&nbsp;&nbsp;<span class='bibentry' >editor</span> = <span class='paranthesis2' >{</span>".preg_replace("/(\.\s*),/", "\\1 and ",$result['editor_name'])."<span class='paranthesis2' >}</span>,<br>\n";
          $body.="&nbsp;&nbsp;<span class='bibentry' >publisher</span> = <span class='paranthesis2' >{</span>".$result['publisher_name']."<span class='paranthesis2' >}</span>,<br>\n";
          break;
        case "booklet" :
          $body.="&nbsp;&nbsp;<span class='bibentry' >howpublished</span> = <span class='paranthesis2' >{</span>".$result['journal']."<span class='paranthesis2' >}</span>,<br>\n";  break;
          $body.="&nbsp;&nbsp;<span class='bibentry' >publisher</span> = <span class='paranthesis2' >{</span>".$result['publisher_name']."<span class='paranthesis2' >}</span>,<br>\n";
        case "conference" :
          $body.="<span class='necessary' title='has to be given'>&nbsp;&nbsp;booktitle = {},</span><br>\n";
          $body.="&nbsp;&nbsp;<span class='bibentry' >series</span> = <span class='paranthesis2' >{</span>".$result['journal']."<span class='paranthesis2' >}</span>,<br>\n";  break;
          $body.="&nbsp;&nbsp;<span class='bibentry' >publisher</span> = <span class='paranthesis2' >{</span>".$result['publisher_name']."<span class='paranthesis2' >}</span>,<br>\n";
        case "inbook" :
          $body.="&nbsp;&nbsp;<span class='bibentry' >series</span> = <span class='paranthesis2' >{</span>".$result['journal']."<span class='paranthesis2' >}</span>,<br>\n";
          $body.="<span class='necessary' title='has to be given'>&nbsp;&nbsp;chapter ={},</span><br>\n";
          $body.="&nbsp;&nbsp;<span class='bibentry' >editor</span> = <span class='paranthesis2' >{</span>".preg_replace("/(\.\s*),/", "\\1 and ",$result['editor_name'])."<span class='paranthesis2' >}</span>,<br>\n";
          $body.="&nbsp;&nbsp;<span class='bibentry' >publisher</span> = <span class='paranthesis2' >{</span>".$result['publisher_name']."<span class='paranthesis2' >}</span>,<br>\n";
          break;
        case "incollection" :
          $body.="&nbsp;&nbsp;<span class='bibentry' >booktitle</span> = <span class='paranthesis2' >{</span>".$result['journal']."<span class='paranthesis2' >}</span>,<br>\n";
          $body.="&nbsp;&nbsp;<span class='bibentry' >editor</span> = <span class='paranthesis2' >{</span>".preg_replace("/(\.\s*),/", "\\1 and ",$result['editor_name'])."<span class='paranthesis2' >}</span>,<br>\n";
          $body.="&nbsp;&nbsp;<span class='bibentry' >publisher</span> = <span class='paranthesis2' >{</span>".$result['publisher_name']."<span class='paranthesis2' >}</span>,<br>\n";
          break;
        case "inproceedings" :
          $body.="&nbsp;&nbsp;<span class='bibentry' >booktitle</span> = <span class='paranthesis2' >{</span>".$result['journal']."<span class='paranthesis2' >}</span>,<br>\n";
          $body.="&nbsp;&nbsp;<span class='bibentry' >publisher</span> = <span class='paranthesis2' >{</span>".$result['publisher_name']."<span class='paranthesis2' >}</span>,<br>\n";
          break;
        case "manual" :
          $body.="&nbsp;&nbsp;<span class='bibentry' >series</span> = <span class='paranthesis2' >{</span>".$result['journal']."<span class='paranthesis2' >}</span>,<br>\n";  break;
        case "mastersthesis" :
          $body.="&nbsp;&nbsp;<span class='bibentry' >school</span> = <span class='paranthesis2' >{</span>".$result['journal']."<span class='paranthesis2' >}</span>,<br>\n";  break;
        case "misc" :
          $body.="&nbsp;&nbsp;<span class='bibentry' >howpublished</span> = <span class='paranthesis2' >{</span>".$result['journal']."<span class='paranthesis2' >}</span>,<br>\n";  break;
          $body.="&nbsp;&nbsp;<span class='bibentry' >publisher</span> = <span class='paranthesis2' >{</span>".$result['publisher_name']."<span class='paranthesis2' >}</span>,<br>\n";
        case "phdthesis" :
          $body.="&nbsp;&nbsp;<span class='bibentry' >school</span> = <span class='paranthesis2' >{</span>".$result['journal']."<span class='paranthesis2' >}</span>,<br>\n";  break;
        case "proceedings" :
          $body.="&nbsp;&nbsp;<span class='bibentry' >series</span> = <span class='paranthesis2' >{</span>".$result['journal']."<span class='paranthesis2' >}</span>,<br>\n";  break;
        case "techreport" :
          $body.="&nbsp;&nbsp;<span class='bibentry' >institution</span> = <span class='paranthesis2' >{</span>".$result['journal']."<span class='paranthesis2' >}</span>,<br>\n";  break;
        case "unpublished" :
          $body.="&nbsp;&nbsp;<span class='bibentry' >howpublished</span> = <span class='paranthesis2' >{</span>".$result['journal']."<span class='paranthesis2' >}</span>,<br>\n";  break;
        case "online" :
          $body.="&nbsp;&nbsp;<span class='bibentry' >organization</span> = <span class='paranthesis2' >{</span>".$result['journal']."<span class='paranthesis2' >}</span>,<br>\n";  break;
        default:
          $body.="&nbsp;&nbsp;<span class='bibentry' >journal</span> = <span class='paranthesis2' >{</span>".$result['journal']."<span class='paranthesis2' >}</span>,<br>\n";
      }
    // keywords={determination key,Chironominae,taxonomic literature},
      $body.="&nbsp;&nbsp;<span class='bibentry' >keywords</span> = <span class='paranthesis2' >{</span>".preg_replace(
        array("/^\s+/","/,\s*/"),
        array(" ",", "),
        $result['keywords'])."<span class='paranthesis2' >}</span>,<br>\n";
    // abstract={},
      $body.=empty($result['abstract'])?"":"&nbsp;&nbsp;<span class='bibentry' >abstract</span> = <span class='paranthesis2' >{</span>".preg_replace("/,\s*/",", ",$result['abstract'])."<span class='paranthesis2' >}</span>,<br>\n";
    // url={},
      $body.=empty($result['journal_url'])?"":"&nbsp;&nbsp;<span class='bibentry' >url</span> = <span class='paranthesis2' >{</span>".$result['journal_url']."<span class='paranthesis2' >}</span>,<br>\n";
    // comment={as copy},
    $result['note']=preg_replace(
      array("/,\s*/", "/\{((citeID|textciteID|numciteID)[^}]+)\}/", "/&/"),
      array(", ", "<acronym title='cite ID-key has to be checked' ><span class='LaTeX'>\cite</span><span class='paranthesis1' >{</span>\\1<span class='paranthesis1' >}</span></acronym>","\&"),
      $result['note']
    );
      $body.="&nbsp;&nbsp;<span class='bibentry' ><acronym title='internal note' >annote</acronym></span> = <span class='paranthesis2' >{</span>".$result['note']."<span class='paranthesis2' >}</span>,<br>\n";
      $body.="&nbsp;&nbsp;<span class='bibentry' ><acronym title='note printed in references' >note</acronym></span> = <span class='paranthesis2' >{</span>".$result['note']."<span class='paranthesis2' >}</span><br>\n";
    $body.="<span class='paranthesis1' >}</span>"; // output end
    $body.="</fieldset>";
  }// end BibTeX output

}// end references

/**
 * AJAX autoSuggestion
 *
 *
 * @annotation AJAX
 */
/**
 * AJAX autoSuggestion
 *
 * See also file queryDB for database requests.
 * @global javascript $autoSuggestion
 */

$autoSuggestion="
  <script type=\"text/javascript\" >
    var options = {
      script:\"queryDB.php?limit=10&table=names_authors&field=author_names&\",
      varname:\"input\",/* variable name of input */
      maxresults:10,
      callback: function (obj) { document.getElementById('ajaxvalues').value = obj.id; }
    };
    var options_short = {
      script:\"queryDB.php?limit=10&table=names_authors&field=authors_short&\",
      varname:\"input\",/* variable name of input */
      maxresults:10,
      callback: function (obj) { document.getElementById('ajaxvalues').value = obj.id; }
    };
    var options_journal = {
      script:\"queryDB.php?limit=10&table=names_authors&field=journal&\",
      varname:\"input\",/* variable name of input */
      maxresults:10,
      callback: function (obj) { document.getElementById('ajaxvalues').value = obj.id; }
    };
    var options_editor = {
      script:\"queryDB.php?limit=10&table=names_authors&field=editor_name&\",
      varname:\"input\",/* variable name of input */
      maxresults:10,
      callback: function (obj) { document.getElementById('ajaxvalues').value = obj.id; }
    };
    var options_keywords = {
      script:\"queryDB.php?limit=10&table=names_authors&field=keywords&\",
      varname:\"input\",/* variable name of input */
      maxresults:10,
      callback: function (obj) { document.getElementById('ajaxvalues').value = obj.id; }
    };
    var as_pubn     = new bsn.AutoSuggest('publisher_name', options);
    var as_auth     = new bsn.AutoSuggest('author_names', options);
    var as_aush     = new bsn.AutoSuggest('authors_short', options_short);
    var as_jour     = new bsn.AutoSuggest('journal', options_journal);
    var as_edit     = new bsn.AutoSuggest('editor_name', options_editor);

  </script>
  ";
// add autoSuggestion if URL has 'refid=new'
$body.= ($_GET["refid"]=='new') ? $autoSuggestion : $autoSuggestion;
// print_r($_POST);
 echo $content.$message.$body.$page['foot'];
unset($_GET);
?>